/* $Id$ */
/*--------------------------------------------------------------------*/
/*;  Copyright (C) 2010-2020                                          */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;  Correspondence concerning Obit should be addressed as follows:   */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
/*  Define the basic components of the ObitImageMosaicMF structure    */
/*  This is intended to be included in a class structure definition   */
/**
 * \file ObitImageMosaicMFDef.h
 * ObitImageMosaicMF structure members for derived classes.
 */
#include "ObitImageMosaicDef.h"  /* Parent class definitions */
/** Maximum beam order Spectral index only = 1, plus curvature = 2 */
olong maxOrder;
/** Maximum IF center fractional bandwidth */
ofloat maxFBW;
/** Spectral index correction applied to data making mosaic */
ofloat alpha;
/** Reference frequency (Hz) for spectral index */
odouble alphaRefF;
/** Is this being restarted? */
gboolean restart;
