/* $Id$   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2013                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#ifndef OBITTABLEIDI_PHASE_CAL_H 
#define OBITTABLEIDI_PHASE_CAL_H 

#include "Obit.h"
#include "ObitErr.h"
#include "ObitTable.h"
#include "ObitData.h"

/*-------- Obit: Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_PHASE_CAL.h
 * ObitTableIDI_PHASE_CAL class definition.
 *
 * This class is derived from the #ObitTable class.
 *
 * This class contains tabular data and allows access.
 * This table is part of the IDI uv data format.
 * "IDI\_PHASE-CAL" contains instrumental phase calibration data
 * Only FITS cataloged data are supported.
 * This class is derived from the ObitTable class.
 *
 * This class contains tabular data and allows access.
 * "IDI_PHASE_CAL" table
 * An ObitTableIDI_PHASE_CAL is the front end to a persistent disk resident structure.
 * Only FITS (as Tables) are supported.
 *
 * \section TableDataStorage Table data storage
 * In memory tables are stored in a fashion similar to how they are 
 * stored on disk - in large blocks in memory rather than structures.
 * Due to the word alignment requirements of some machines, they are 
 * stored by order of the decreasing element size: 
 * double, float long, int, short, char rather than the logical order.
 * The details of the storage in the buffer are kept in the 
 * #ObitTableIDI_PHASE_CALDesc.
 *
 * In addition to the normal tabular data, a table will have a "_status"
 * column to indicate the status of each row.
 *
 * \section ObitTableIDI_PHASE_CALSpecification Specifying desired data transfer parameters
 * The desired data transfers are specified in the member ObitInfoList.
 * In the following an ObitInfoList entry is defined by 
 * the name in double quotes, the data type code as an #ObitInfoType enum 
 * and the dimensions of the array (? => depends on application).
 *
 * The following apply to both types of files:
 * \li "nRowPIO", OBIT_int, Max. Number of visibilities per 
 *     "Read" or "Write" operation.  Default = 1.
 *
 * \subsection TableFITS FITS files
 * This implementation uses cfitsio which allows using, in addition to 
 * regular FITS images, gzip compressed files, pipes, shared memory 
 * and a number of other input forms.
 * The convenience Macro #ObitTableIDI_PHASE_CALSetFITS simplifies specifying the 
 * desired data.
 * Binary tables are used for storing visibility data in FITS.
 * For accessing FITS files the following entries in the ObitInfoList 
 * are used:
 * \li "FileName" OBIT_string (?,1,1) FITS file name.
 * \li "TabName"  OBIT_string (?,1,1) Table name (e.g. "AIPS CC").
 * \li "Ver"      OBIT_int    (1,1,1) Table version number
 *
 *
 * \section ObitTableIDI_PHASE_CALaccess Creators and Destructors
 * An ObitTableIDI_PHASE_CAL can be created using newObitTableIDI_PHASE_CALValue which attaches the 
 * table to an ObitData for the object.  
 * If the output ObitTableIDI_PHASE_CAL has previously been specified, including file information,
 * then ObitTableIDI_PHASE_CALCopy will copy the disk resident as well as the memory 
 * resident information.
 *
 * A copy of a pointer to an ObitTableIDI_PHASE_CAL should always be made using the
 * ObitTableIDI_PHASE_CALRef function which updates the reference count in the object.
 * Then whenever freeing an ObitTableIDI_PHASE_CAL or changing a pointer, the function
 * ObitTableIDI_PHASE_CALUnref will decrement the reference count and destroy the object
 * when the reference count hits 0.
 *
 * \section ObitTableIDI_PHASE_CALUsage I/O
 * Visibility data is available after an input object is "Opened"
 * and "Read".
 * I/O optionally uses a buffer attached to the ObitTableIDI_PHASE_CAL or some external
 * location.
 * To Write an ObitTableIDI_PHASE_CAL, create it, open it, and write.
 * The object should be closed to ensure all data is flushed to disk.
 * Deletion of an ObitTableIDI_PHASE_CAL after its final unreferencing will automatically
 * close it.
 */

/*--------------Class definitions-------------------------------------*/

/** Number of characters for Table keyword */
 #define MAXKEYCHARTABLEIDI_PHASE_CAL 24

/** ObitTableIDI_PHASE_CAL Class structure. */
typedef struct {
#include "ObitTableIDI_PHASE_CALDef.h"   /* this class definition */
} ObitTableIDI_PHASE_CAL;

/** ObitTableIDI_PHASE_CALRow Class structure. */
typedef struct {
#include "ObitTableIDI_PHASE_CALRowDef.h"   /* this class row definition */
} ObitTableIDI_PHASE_CALRow;

/*----------------- Macroes ---------------------------*/
/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_PHASE_CAL
 * returns an ObitTableIDI_PHASE_CAL*.
 * in = object to unreference
 */
#define ObitTableIDI_PHASE_CALUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_PHASE_CAL.
 * returns an ObitTableIDI_PHASE_CAL*.
 * in = object to reference
 */
#define ObitTableIDI_PHASE_CALRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_PHASE_CALIsA(in) ObitIsA (in, ObitTableIDI_PHASE_CALGetClass())

/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_PHASE_CALRow
 * returns an ObitTableIDI_PHASE_CALRow*.
 * in = object to unreference
 */
#define ObitTableIDI_PHASE_CALRowUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_PHASE_CALRow.
 * returns an ObitTableIDI_PHASE_CALRow*.
 * in = object to reference
 */
#define ObitTableIDI_PHASE_CALRowRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_PHASE_CALRowIsA(in) ObitIsA (in, ObitTableIDI_PHASE_CALRowGetClass())

/*---------------Public functions---------------------------*/
/*----------------Table Row Functions ----------------------*/
/** Public: Row Class initializer. */
void ObitTableIDI_PHASE_CALRowClassInit (void);

/** Public: Constructor. */
ObitTableIDI_PHASE_CALRow* newObitTableIDI_PHASE_CALRow (ObitTableIDI_PHASE_CAL *table);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_PHASE_CALRowGetClass (void);

/*------------------Table Functions ------------------------*/
/** Public: Class initializer. */
void ObitTableIDI_PHASE_CALClassInit (void);

/** Public: Constructor. */
ObitTableIDI_PHASE_CAL* newObitTableIDI_PHASE_CAL (gchar* name);

/** Public: Constructor from values. */
ObitTableIDI_PHASE_CAL* 
newObitTableIDI_PHASE_CALValue (gchar* name, ObitData *file, olong *ver,
  		     ObitIOAccess access,
                     oint numPol, oint no_band, oint numTones,
		     ObitErr *err);

/** Public: Class initializer. */
void ObitTableIDI_PHASE_CALClassInit (void);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_PHASE_CALGetClass (void);

/** Public: Copy (deep) constructor. */
ObitTableIDI_PHASE_CAL* ObitTableIDI_PHASE_CALCopy  (ObitTableIDI_PHASE_CAL *in, ObitTableIDI_PHASE_CAL *out, 
			   ObitErr *err);

/** Public: Copy (shallow) constructor. */
ObitTableIDI_PHASE_CAL* ObitTableIDI_PHASE_CALClone (ObitTableIDI_PHASE_CAL *in, ObitTableIDI_PHASE_CAL *out);

/** Public: Convert an ObitTable to an ObitTableIDI_PHASE_CAL */
ObitTableIDI_PHASE_CAL* ObitTableIDI_PHASE_CALConvert  (ObitTable *in);

/** Public: Create ObitIO structures and open file */
ObitIOCode ObitTableIDI_PHASE_CALOpen (ObitTableIDI_PHASE_CAL *in, ObitIOAccess access, 
			  ObitErr *err);

/** Public: Read a table row */
ObitIOCode 
ObitTableIDI_PHASE_CALReadRow  (ObitTableIDI_PHASE_CAL *in, olong iIDI_PHASE_CALRow, ObitTableIDI_PHASE_CALRow *row,
		     ObitErr *err);

/** Public: Init a table row for write */
void 
ObitTableIDI_PHASE_CALSetRow  (ObitTableIDI_PHASE_CAL *in, ObitTableIDI_PHASE_CALRow *row,
		     ObitErr *err);

/** Public: Write a table row */
ObitIOCode 
ObitTableIDI_PHASE_CALWriteRow  (ObitTableIDI_PHASE_CAL *in, olong iIDI_PHASE_CALRow, ObitTableIDI_PHASE_CALRow *row,
		     ObitErr *err);

/** Public: Close file and become inactive */
ObitIOCode ObitTableIDI_PHASE_CALClose (ObitTableIDI_PHASE_CAL *in, ObitErr *err);

/*----------- ClassInfo Structure -----------------------------------*/
/**
 * ClassInfo Structure.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_PHASE_CALClassDef.h"
} ObitTableIDI_PHASE_CALClassInfo; 

/**
 * ClassInfo Structure For TableIDI_PHASE_CALRow.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_PHASE_CALRowClassDef.h"
} ObitTableIDI_PHASE_CALRowClassInfo; 
#endif /* OBITTABLEIDI_PHASE_CAL_H */ 
