/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2016                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
/*  Define the basic components of the ObitTableRow structure       */
/*  This is intended to be included in a class structure definition   */
/**
 * \file ObitTablePTRowDef.h
 * ObitTablePTRow structure members for derived classes.
 */
#include "ObitTableRowDef.h"  /* Parent class definitions */
/** The center time wrt RefDate */
odouble  Time;
/** Interval over which pointing valid. */
ofloat  TimeI;
/** Antenna number */
oint  antNo;
/** The antenna was in tracking mode? */
gboolean  pointingTracking;
/** Use polynomials expansions? */
gboolean  usePolynomials;
/** The value used as origin in the polynomials expansions */
odouble  timeOrigin;
/** Refers to a collection of rows in PointingModelTable. */
oint  pointingModelId;
/** [OPTIONAL] Pointing at elevations larger than 90 degrees (true) or lower (false). */
gboolean  overTheTop;
/** [OPTIONAL] The direction reference code associated to the source offset. */
oint  SourceReferenceCodeOffset;
/** [OPTIONAL] The equinox information (if needed by sourceReferenceCode). */
odouble  sourceEquinoxOffset;
/** Encoder values in Az,El */
ofloat*  Encoder;
/** The commanded pointing direction in Az,El per term */
odouble*  PointingDirection;
/** The direction of the field center in Az,El per term. */
odouble*  target;
/** The offset of the pointing direction at the time of the visibility */
odouble*  offset;
/** [OPTIONAL] Sources offset in Az,El per term of the polynomia). */
odouble*  SourceOffset;
/** [OPTIONAL] An array of start, end of interval which must be given explicitly i */
odouble*  sampledTimeInterval;
/** [OPTIONAL] This is the correction applied to the commanded position in Az,El to take */
ofloat*  AtmosphericCorrection;
/** status 0=normal, 1=modified, -1=flagged */
olong  status;
