/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableBL.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableBL.c
 * ObitTableBL class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableBL";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableBLRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableBLRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableBLClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableBLClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableBLRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableBLRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableBLInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableBLClear (gpointer in);

/** Private: update table specific info */
static void ObitTableBLUpdate (ObitTableBL *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableBLDumpKey (ObitTableBL *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableBLClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableBLRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableBLRow* newObitTableBLRow (ObitTableBL *table)
{
  ObitTableBLRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableBLRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableBLRow));

  /* initialize values */
  out->name = g_strdup("TableBL Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableBLRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->RealM1 = fRow + table->RealM1Off;
    if (table->numPol>=1) out->ImagM1 = fRow + table->ImagM1Off;
    if (table->numPol>=1) out->RealA1 = fRow + table->RealA1Off;
    if (table->numPol>=1) out->ImagA1 = fRow + table->ImagA1Off;
    if (table->numPol>=2) out->RealM2 = fRow + table->RealM2Off;
    if (table->numPol>=2) out->ImagM2 = fRow + table->ImagM2Off;
    if (table->numPol>=2) out->RealA2 = fRow + table->RealA2Off;
    if (table->numPol>=2) out->ImagA2 = fRow + table->ImagA2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableBLRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableBLRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableBLRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableBLRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableBL* newObitTableBL (gchar* name)
{
  ObitTableBL* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBLClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableBL));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableBLInit((gpointer)out);

 return out;
} /* end newObitTableBL */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableBLGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBLClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitBLGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations
 * \param numIF The number of IFs
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableBL* newObitTableBLValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numIF,
		     ObitErr *err)
{
  ObitTableBL* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS BL";
  gchar *routine = "newObitTableBLValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBLClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS BL");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableBL */
      if (ObitTableBLIsA(testTab)) { /* it is an ObitTableBL */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableBLConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS BL");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableBLIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableBLConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numIF = MAX (0, numIF);

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 6 + out->numPol*4 + out->numIF*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA1   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA2   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQ ID    ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REAL M1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("IMAG M1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REAL A1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("IMAG A1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REAL M2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("IMAG M2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REAL A2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("IMAG A2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableBLDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableBLOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableBLClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableBLValue */

/**
 * Convert an ObitTable to an ObitTableBL.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableBL* ObitTableBLConvert (ObitTable* in)
{
  ObitTableBL *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableBL(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableBLConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableBL* ObitTableBLCopy (ObitTableBL *in, ObitTableBL *out, ObitErr *err)
{
  gchar *routine = "ObitTableBLCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBLClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableBL*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->numAnt = in->numAnt;
  out->numPol = in->numPol;
  out->numIF = in->numIF;
  /* Update class specific info */
  ObitTableBLUpdate (out, err);
    
  return out;
} /* end ObitTableBLCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableBLOpen (ObitTableBL *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableBLOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBLClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableBLUpdate (in, err);
   
   return retCode;
} /* end ObitTableBLOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iBLRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableBLReadRow  (ObitTableBL *in, olong iBLRow, ObitTableBLRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableBLReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS BL Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iBLRow */
  retCode = ObitTableRead ((ObitTable*)in, iBLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = fRow[in->TimeOff];
  row->SourID = iRow[in->SourIDOff];
  row->SubA = iRow[in->SubAOff];
  row->ant1 = iRow[in->ant1Off];
  row->ant2 = iRow[in->ant2Off];
  row->FreqID = iRow[in->FreqIDOff];
  if (in->numPol>=1) row->RealM1 = fRow + in->RealM1Off;
  if (in->numPol>=1) row->ImagM1 = fRow + in->ImagM1Off;
  if (in->numPol>=1) row->RealA1 = fRow + in->RealA1Off;
  if (in->numPol>=1) row->ImagA1 = fRow + in->ImagA1Off;
  if (in->numPol>=2) row->RealM2 = fRow + in->RealM2Off;
  if (in->numPol>=2) row->ImagM2 = fRow + in->ImagM2Off;
  if (in->numPol>=2) row->RealA2 = fRow + in->RealA2Off;
  if (in->numPol>=2) row->ImagA2 = fRow + in->ImagA2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableBLReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableBLSetRow  (ObitTableBL *in, ObitTableBLRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "BL Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->RealM1 = fRow + in->RealM1Off;
  if (in->numPol>=1) row->ImagM1 = fRow + in->ImagM1Off;
  if (in->numPol>=1) row->RealA1 = fRow + in->RealA1Off;
  if (in->numPol>=1) row->ImagA1 = fRow + in->ImagA1Off;
  if (in->numPol>=2) row->RealM2 = fRow + in->RealM2Off;
  if (in->numPol>=2) row->ImagM2 = fRow + in->ImagM2Off;
  if (in->numPol>=2) row->RealA2 = fRow + in->RealA2Off;
  if (in->numPol>=2) row->ImagA2 = fRow + in->ImagA2Off;

} /*  end ObitTableBLSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableBLSetRow  
 * \param in       Table to read
 * \param iBLRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableBLWriteRow  (ObitTableBL *in, olong iBLRow, ObitTableBLRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableBLWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS BL Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  fRow[in->TimeOff] = row->Time;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->SubAOff] = row->SubA;
  iRow[in->ant1Off] = row->ant1;
  iRow[in->ant2Off] = row->ant2;
  iRow[in->FreqIDOff] = row->FreqID;
  if (in->numPol>=1)
    if (in->RealM1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RealM1Col]; i++) 
        fRow[in->RealM1Off+i] = row->RealM1[i];
    } 
  if (in->numPol>=1)
    if (in->ImagM1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->ImagM1Col]; i++) 
        fRow[in->ImagM1Off+i] = row->ImagM1[i];
    } 
  if (in->numPol>=1)
    if (in->RealA1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RealA1Col]; i++) 
        fRow[in->RealA1Off+i] = row->RealA1[i];
    } 
  if (in->numPol>=1)
    if (in->ImagA1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->ImagA1Col]; i++) 
        fRow[in->ImagA1Off+i] = row->ImagA1[i];
    } 
  if (in->numPol>=2)
    if (in->RealM2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RealM2Col]; i++) 
        fRow[in->RealM2Off+i] = row->RealM2[i];
    } 
  if (in->numPol>=2)
    if (in->ImagM2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->ImagM2Col]; i++) 
        fRow[in->ImagM2Off+i] = row->ImagM2[i];
    } 
  if (in->numPol>=2)
    if (in->RealA2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->RealA2Col]; i++) 
        fRow[in->RealA2Off+i] = row->RealA2[i];
    } 
  if (in->numPol>=2)
    if (in->ImagA2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->ImagA2Col]; i++) 
        fRow[in->ImagA2Off+i] = row->ImagA2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iBLRow */
  retCode = ObitTableWrite ((ObitTable*)in, iBLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableBLWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableBLClose (ObitTableBL *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableBLClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableBLDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableBLClose */

/*---------------Private functions--------------------------*/
/*----------------  TableBL Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableBLRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBLRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->RealM1 = NULL;
  in->ImagM1 = NULL;
  in->RealA1 = NULL;
  in->ImagA1 = NULL;
  in->RealM2 = NULL;
  in->ImagM2 = NULL;
  in->RealA2 = NULL;
  in->ImagA2 = NULL;

} /* end ObitTableBLRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableBLRow* cast to an Obit*.
 */
void ObitTableBLRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBLRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableBLRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableBLRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableBLRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableBLRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableBLRowClassInfoDefFn (gpointer inClass)
{
  ObitTableBLRowClassInfo *theClass = (ObitTableBLRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableBLRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableBLRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableBLRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableBLRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableBLRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableBLRowInit;

} /* end ObitTableBLRowClassDefFn */

/*------------------  TableBL  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableBLInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBL *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableBLInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableBL* cast to an Obit*.
 */
void ObitTableBLClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBL *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableBLClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableBLClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableBLClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableBLClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableBLClassInfoDefFn (gpointer inClass)
{
  ObitTableBLClassInfo *theClass = (ObitTableBLClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableBLClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableBLClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableBLGetClass;
  theClass->newObit       = (newObitFP)newObitTableBL;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableBLCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableBLClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableBLInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableBLConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableBLOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableBLClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableBLReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableBLWriteRow;

} /* end ObitTableBLClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableBLUpdate (ObitTableBL *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* numAnt */
  if (!ObitInfoListGet(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->numAnt, err)) return;
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* numIF */
  if (!ObitInfoListGet(in->myDesc->info, "NO_IF", &type, dim, 
		       (gpointer)&in->numIF, err)) return;

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->SubAOff = -1;
  in->SubACol = -1;
  in->ant1Off = -1;
  in->ant1Col = -1;
  in->ant2Off = -1;
  in->ant2Col = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->RealM1Off = -1;
  in->RealM1Col = -1;
  in->ImagM1Off = -1;
  in->ImagM1Col = -1;
  in->RealA1Off = -1;
  in->RealA1Col = -1;
  in->ImagA1Off = -1;
  in->ImagA1Col = -1;
  in->RealM2Off = -1;
  in->RealM2Col = -1;
  in->ImagM2Off = -1;
  in->ImagM2Col = -1;
  in->RealA2Off = -1;
  in->RealA2Col = -1;
  in->ImagA2Off = -1;
  in->ImagA2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE ID  ", 11)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY   ", 11)) {
	 in->SubAOff = desc->offset[i];
 	 in->SubACol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA1   ", 11)) {
	 in->ant1Off = desc->offset[i];
 	 in->ant1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA2   ", 11)) {
	 in->ant2Off = desc->offset[i];
 	 in->ant2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ ID    ", 11)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL M1", 7)) {
	     in->RealM1Off = desc->offset[i];
 	     in->RealM1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG M1", 7)) {
	     in->ImagM1Off = desc->offset[i];
 	     in->ImagM1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL A1", 7)) {
	     in->RealA1Off = desc->offset[i];
 	     in->RealA1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG A1", 7)) {
	     in->ImagA1Off = desc->offset[i];
 	     in->ImagA1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL M2", 7)) {
	     in->RealM2Off = desc->offset[i];
 	     in->RealM2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG M2", 7)) {
	     in->ImagM2Off = desc->offset[i];
 	     in->ImagM2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL A2", 7)) {
	     in->RealA2Off = desc->offset[i];
 	     in->RealA2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG A2", 7)) {
	     in->ImagA2Off = desc->offset[i];
 	     in->ImagA2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableBLUpdate: Could not find column Time");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableBLUpdate: Could not find column SourID");
  Obit_return_if_fail((in->SubAOff > -1), err,
       "ObitTableBLUpdate: Could not find column SubA");
  Obit_return_if_fail((in->ant1Off > -1), err,
       "ObitTableBLUpdate: Could not find column ant1");
  Obit_return_if_fail((in->ant2Off > -1), err,
       "ObitTableBLUpdate: Could not find column ant2");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableBLUpdate: Could not find column FreqID");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->RealM1Off > -1), err,
       "ObitTableBLUpdate: Could not find column RealM1");
    Obit_return_if_fail((in->ImagM1Off > -1), err,
       "ObitTableBLUpdate: Could not find column ImagM1");
    Obit_return_if_fail((in->RealA1Off > -1), err,
       "ObitTableBLUpdate: Could not find column RealA1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->RealM2Off > -1), err,
       "ObitTableBLUpdate: Could not find column RealM2");
    Obit_return_if_fail((in->ImagM2Off > -1), err,
       "ObitTableBLUpdate: Could not find column ImagM2");
    Obit_return_if_fail((in->RealA2Off > -1), err,
       "ObitTableBLUpdate: Could not find column RealA2");
  } /* end of if index in range */
} /* end ObitTableBLUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableBLDumpKey (ObitTableBL *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* numAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->numAnt);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* numIF */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_IF", type, dim, 
		  (gpointer)&in->numIF);
   
} /* end ObitTableBLDumpKey */
