/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableBP.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableBP.c
 * ObitTableBP class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableBP";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableBPRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableBPRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableBPClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableBPClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableBPRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableBPRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableBPInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableBPClear (gpointer in);

/** Private: update table specific info */
static void ObitTableBPUpdate (ObitTableBP *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableBPDumpKey (ObitTableBP *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableBPClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableBPRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableBPRow* newObitTableBPRow (ObitTableBP *table)
{
  ObitTableBPRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableBPRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableBPRow));

  /* initialize values */
  out->name = g_strdup("TableBP Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableBPRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->ChanShift = dRow + table->ChanShiftOff;
    if (table->numPol>=1) out->RefAnt1 = iRow[table->RefAnt1Off];
    if (table->numPol>=1) out->Weight1 = fRow + table->Weight1Off;
    if (table->numPol>=1) out->Real1 = fRow + table->Real1Off;
    if (table->numPol>=1) out->Imag1 = fRow + table->Imag1Off;
    if (table->numPol>=2) out->RefAnt2 = iRow[table->RefAnt2Off];
    if (table->numPol>=2) out->Weight2 = fRow + table->Weight2Off;
    if (table->numPol>=2) out->Real2 = fRow + table->Real2Off;
    if (table->numPol>=2) out->Imag2 = fRow + table->Imag2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableBPRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableBPRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableBPRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableBPRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableBP* newObitTableBP (gchar* name)
{
  ObitTableBP* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBPClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableBP));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableBPInit((gpointer)out);

 return out;
} /* end newObitTableBP */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableBPGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBPClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitBPGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of antennas
 * \param numIF The number of IFs
 * \param numChan Number of frequency channels
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableBP* newObitTableBPValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numIF, oint numChan,
		     ObitErr *err)
{
  ObitTableBP* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS BP";
  gchar *routine = "newObitTableBPValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBPClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS BP");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableBP */
      if (ObitTableBPIsA(testTab)) { /* it is an ObitTableBP */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableBPConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS BP");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableBPIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableBPConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numIF = MAX (0, numIF);
  out->numChan = MAX (0, numChan);
  out->startChan = 1;
  out->numShifts = 1;
  out->lowShift = 1;
  out->shiftInc = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 8 + out->numPol*4 + out->numIF*0 + out->numChan*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("INTERVAL ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE ID ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("BANDWIDTH ");
  desc->FieldUnit[colNo] = g_strdup("HZ");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("CHN_SHIFT ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("FREQ ID ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REFANT 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("WEIGHT 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REAL 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numChan;
    desc->dim[colNo][1] = numIF;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("IMAG 1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numChan;
    desc->dim[colNo][1] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REFANT 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("WEIGHT 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REAL 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numChan;
    desc->dim[colNo][1] = numIF;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("IMAG 2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numChan;
    desc->dim[colNo][1] = numIF;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableBPDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableBPOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableBPClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableBPValue */

/**
 * Convert an ObitTable to an ObitTableBP.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableBP* ObitTableBPConvert (ObitTable* in)
{
  ObitTableBP *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableBP(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableBPConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableBP* ObitTableBPCopy (ObitTableBP *in, ObitTableBP *out, ObitErr *err)
{
  gchar *routine = "ObitTableBPCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBPClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableBP*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->numAnt = in->numAnt;
  out->numPol = in->numPol;
  out->numIF = in->numIF;
  out->numChan = in->numChan;
  out->startChan = in->startChan;
  out->numShifts = in->numShifts;
  out->lowShift = in->lowShift;
  out->shiftInc = in->shiftInc;
  strncpy (out->BPType, in->BPType, MAXKEYCHARTABLEBP );
  /* Update class specific info */
  ObitTableBPUpdate (out, err);
    
  return out;
} /* end ObitTableBPCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableBPOpen (ObitTableBP *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableBPOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableBPClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableBPUpdate (in, err);
   
   return retCode;
} /* end ObitTableBPOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iBPRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableBPReadRow  (ObitTableBP *in, olong iBPRow, ObitTableBPRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableBPReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS BP Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iBPRow */
  retCode = ObitTableRead ((ObitTable*)in, iBPRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->SourID = iRow[in->SourIDOff];
  row->SubA = iRow[in->SubAOff];
  row->antNo = iRow[in->antNoOff];
  row->BW = fRow[in->BWOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->ChanShift = dRow + in->ChanShiftOff;
  if (in->numPol>=1) row->RefAnt1 = iRow[in->RefAnt1Off];
  if (in->numPol>=1) row->Weight1 = fRow + in->Weight1Off;
  if (in->numPol>=1) row->Real1 = fRow + in->Real1Off;
  if (in->numPol>=1) row->Imag1 = fRow + in->Imag1Off;
  if (in->numPol>=2) row->RefAnt2 = iRow[in->RefAnt2Off];
  if (in->numPol>=2) row->Weight2 = fRow + in->Weight2Off;
  if (in->numPol>=2) row->Real2 = fRow + in->Real2Off;
  if (in->numPol>=2) row->Imag2 = fRow + in->Imag2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableBPReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableBPSetRow  (ObitTableBP *in, ObitTableBPRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "BP Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->ChanShift = dRow + in->ChanShiftOff;
  if (in->numPol>=1) row->RefAnt1 = iRow[in->RefAnt1Off];
  if (in->numPol>=1) row->Weight1 = fRow + in->Weight1Off;
  if (in->numPol>=1) row->Real1 = fRow + in->Real1Off;
  if (in->numPol>=1) row->Imag1 = fRow + in->Imag1Off;
  if (in->numPol>=2) row->RefAnt2 = iRow[in->RefAnt2Off];
  if (in->numPol>=2) row->Weight2 = fRow + in->Weight2Off;
  if (in->numPol>=2) row->Real2 = fRow + in->Real2Off;
  if (in->numPol>=2) row->Imag2 = fRow + in->Imag2Off;

} /*  end ObitTableBPSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableBPSetRow  
 * \param in       Table to read
 * \param iBPRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableBPWriteRow  (ObitTableBP *in, olong iBPRow, ObitTableBPRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableBPWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS BP Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->SubAOff] = row->SubA;
  iRow[in->antNoOff] = row->antNo;
  fRow[in->BWOff] = row->BW;
  iRow[in->FreqIDOff] = row->FreqID;
  if (in->ChanShiftCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->ChanShiftCol]; i++) 
      dRow[in->ChanShiftOff+i] = row->ChanShift[i];
  } 
  if (in->numPol>=1) iRow[in->RefAnt1Off] = row->RefAnt1;
  if (in->numPol>=1)
    if (in->Weight1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Weight1Col]; i++) 
        fRow[in->Weight1Off+i] = row->Weight1[i];
    } 
  if (in->numPol>=1)
    if (in->Real1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Real1Col]; i++) 
        fRow[in->Real1Off+i] = row->Real1[i];
    } 
  if (in->numPol>=1)
    if (in->Imag1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Imag1Col]; i++) 
        fRow[in->Imag1Off+i] = row->Imag1[i];
    } 
  if (in->numPol>=2) iRow[in->RefAnt2Off] = row->RefAnt2;
  if (in->numPol>=2)
    if (in->Weight2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Weight2Col]; i++) 
        fRow[in->Weight2Off+i] = row->Weight2[i];
    } 
  if (in->numPol>=2)
    if (in->Real2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Real2Col]; i++) 
        fRow[in->Real2Off+i] = row->Real2[i];
    } 
  if (in->numPol>=2)
    if (in->Imag2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Imag2Col]; i++) 
        fRow[in->Imag2Off+i] = row->Imag2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iBPRow */
  retCode = ObitTableWrite ((ObitTable*)in, iBPRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableBPWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableBPClose (ObitTableBP *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableBPClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableBPDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableBPClose */

/*---------------Private functions--------------------------*/
/*----------------  TableBP Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableBPRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBPRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->ChanShift = NULL;
  in->Weight1 = NULL;
  in->Real1 = NULL;
  in->Imag1 = NULL;
  in->Weight2 = NULL;
  in->Real2 = NULL;
  in->Imag2 = NULL;

} /* end ObitTableBPRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableBPRow* cast to an Obit*.
 */
void ObitTableBPRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBPRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableBPRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableBPRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableBPRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableBPRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableBPRowClassInfoDefFn (gpointer inClass)
{
  ObitTableBPRowClassInfo *theClass = (ObitTableBPRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableBPRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableBPRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableBPRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableBPRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableBPRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableBPRowInit;

} /* end ObitTableBPRowClassDefFn */

/*------------------  TableBP  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableBPInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBP *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableBPInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableBP* cast to an Obit*.
 */
void ObitTableBPClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableBP *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableBPClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableBPClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableBPClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableBPClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableBPClassInfoDefFn (gpointer inClass)
{
  ObitTableBPClassInfo *theClass = (ObitTableBPClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableBPClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableBPClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableBPGetClass;
  theClass->newObit       = (newObitFP)newObitTableBP;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableBPCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableBPClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableBPInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableBPConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableBPOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableBPClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableBPReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableBPWriteRow;

} /* end ObitTableBPClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableBPUpdate (ObitTableBP *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* numAnt */
  if (!ObitInfoListGet(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->numAnt, err)) return;
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* numIF */
  in->numIF = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_IF", &type, dim, 
		       (gpointer)&in->numIF);
   /* numChan */
  in->numChan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->numChan);
   /* startChan */
  in->startChan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "STRT_CHN", &type, dim, 
		       (gpointer)&in->startChan);
   /* numShifts */
  in->numShifts = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_SHFTS", &type, dim, 
		       (gpointer)&in->numShifts);
   /* lowShift */
  in->lowShift = 1; 
  ObitInfoListGetTest(in->myDesc->info, "LOW_SHFT", &type, dim, 
		       (gpointer)&in->lowShift);
   /* shiftInc */
  in->shiftInc = 1; 
  ObitInfoListGetTest(in->myDesc->info, "SHFT_INC", &type, dim, 
		       (gpointer)&in->shiftInc);
   /* BPType */
  if (!ObitInfoListGet(in->myDesc->info, "BP_TYPE", &type, dim, 
		       (gpointer)&in->BPType, err)) return;

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->SubAOff = -1;
  in->SubACol = -1;
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->BWOff = -1;
  in->BWCol = -1;
  in->ChanShiftOff = -1;
  in->ChanShiftCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->RefAnt1Off = -1;
  in->RefAnt1Col = -1;
  in->Weight1Off = -1;
  in->Weight1Col = -1;
  in->Real1Off = -1;
  in->Real1Col = -1;
  in->Imag1Off = -1;
  in->Imag1Col = -1;
  in->RefAnt2Off = -1;
  in->RefAnt2Col = -1;
  in->Weight2Off = -1;
  in->Weight2Col = -1;
  in->Real2Off = -1;
  in->Real2Col = -1;
  in->Imag2Off = -1;
  in->Imag2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "INTERVAL ", 9)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE ID ", 10)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY ", 9)) {
	 in->SubAOff = desc->offset[i];
 	 in->SubACol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA ", 8)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BANDWIDTH ", 10)) {
	 in->BWOff = desc->offset[i];
 	 in->BWCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CHN_SHIFT ", 10)) {
	 in->ChanShiftOff = desc->offset[i];
 	 in->ChanShiftCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ ID ", 8)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT 1", 8)) {
	     in->RefAnt1Off = desc->offset[i];
 	     in->RefAnt1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT 1", 8)) {
	     in->Weight1Off = desc->offset[i];
 	     in->Weight1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL 1", 6)) {
	     in->Real1Off = desc->offset[i];
 	     in->Real1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG 1", 6)) {
	     in->Imag1Off = desc->offset[i];
 	     in->Imag1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT 2", 8)) {
	     in->RefAnt2Off = desc->offset[i];
 	     in->RefAnt2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT 2", 8)) {
	     in->Weight2Off = desc->offset[i];
 	     in->Weight2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL 2", 6)) {
	     in->Real2Off = desc->offset[i];
 	     in->Real2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG 2", 6)) {
	     in->Imag2Off = desc->offset[i];
 	     in->Imag2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableBPUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableBPUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableBPUpdate: Could not find column SourID");
  Obit_return_if_fail((in->SubAOff > -1), err,
       "ObitTableBPUpdate: Could not find column SubA");
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTableBPUpdate: Could not find column antNo");
  Obit_return_if_fail((in->BWOff > -1), err,
       "ObitTableBPUpdate: Could not find column BW");
  Obit_return_if_fail((in->ChanShiftOff > -1), err,
       "ObitTableBPUpdate: Could not find column ChanShift");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableBPUpdate: Could not find column FreqID");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->RefAnt1Off > -1), err,
       "ObitTableBPUpdate: Could not find column RefAnt1");
    Obit_return_if_fail((in->Weight1Off > -1), err,
       "ObitTableBPUpdate: Could not find column Weight1");
    Obit_return_if_fail((in->Real1Off > -1), err,
       "ObitTableBPUpdate: Could not find column Real1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->RefAnt2Off > -1), err,
       "ObitTableBPUpdate: Could not find column RefAnt2");
    Obit_return_if_fail((in->Weight2Off > -1), err,
       "ObitTableBPUpdate: Could not find column Weight2");
    Obit_return_if_fail((in->Real2Off > -1), err,
       "ObitTableBPUpdate: Could not find column Real2");
  } /* end of if index in range */
} /* end ObitTableBPUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableBPDumpKey (ObitTableBP *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* numAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->numAnt);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* numIF */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_IF", type, dim, 
		  (gpointer)&in->numIF);
  /* numChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->numChan);
  /* startChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STRT_CHN", type, dim, 
		  (gpointer)&in->startChan);
  /* numShifts */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_SHFTS", type, dim, 
		  (gpointer)&in->numShifts);
  /* lowShift */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "LOW_SHFT", type, dim, 
		  (gpointer)&in->lowShift);
  /* shiftInc */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "SHFT_INC", type, dim, 
		  (gpointer)&in->shiftInc);
  /* BPType */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEBP;
  ObitInfoListAlwaysPut(info, "BP_TYPE", type, dim, 
		  (gpointer)&in->BPType);
   
} /* end ObitTableBPDumpKey */
