/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableGC.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableGC.c
 * ObitTableGC class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableGC";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableGCRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableGCRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableGCClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableGCClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableGCRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableGCRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableGCInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableGCClear (gpointer in);

/** Private: update table specific info */
static void ObitTableGCUpdate (ObitTableGC *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableGCDumpKey (ObitTableGC *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableGCClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableGCRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableGCRow* newObitTableGCRow (ObitTableGC *table)
{
  ObitTableGCRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableGCRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableGCRow));

  /* initialize values */
  out->name = g_strdup("TableGC Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableGCRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->Type1 = iRow + table->Type1Off;
    if (table->numPol>=1) out->NTerm1 = iRow + table->NTerm1Off;
    if (table->numPol>=1) out->XTyp1 = iRow + table->XTyp1Off;
    if (table->numPol>=1) out->YTyp1 = iRow + table->YTyp1Off;
    if (table->numPol>=1) out->XVal1 = fRow + table->XVal1Off;
    if (table->numPol>=1) out->YVal1 = fRow + table->YVal1Off;
    if (table->numPol>=1) out->gain1 = fRow + table->gain1Off;
    if (table->numPol>=1) out->sens1 = fRow + table->sens1Off;
    if (table->numPol>=2) out->Type2 = iRow + table->Type2Off;
    if (table->numPol>=2) out->NTerm2 = iRow + table->NTerm2Off;
    if (table->numPol>=2) out->XTyp2 = iRow + table->XTyp2Off;
    if (table->numPol>=2) out->YTyp2 = iRow + table->YTyp2Off;
    if (table->numPol>=2) out->XVal2 = fRow + table->XVal2Off;
    if (table->numPol>=2) out->YVal2 = fRow + table->YVal2Off;
    if (table->numPol>=2) out->gain2 = fRow + table->gain2Off;
    if (table->numPol>=2) out->sens2 = fRow + table->sens2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableGCRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableGCRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableGCRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableGCRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableGC* newObitTableGC (gchar* name)
{
  ObitTableGC* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableGCClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableGC));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableGCInit((gpointer)out);

 return out;
} /* end newObitTableGC */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableGCGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableGCClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitGCGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numBand The number of Bands(?).
 * \param numPol The number of polarizations.
 * \param numTabs The number of ??.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableGC* newObitTableGCValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numBand, oint numPol, oint numTabs,
		     ObitErr *err)
{
  ObitTableGC* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS GC";
  gchar *routine = "newObitTableGCValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableGCClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS GC");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableGC */
      if (ObitTableGCIsA(testTab)) { /* it is an ObitTableGC */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableGCConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS GC");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableGCIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableGCConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numBand = MAX (0, numBand);
  out->numPol = MAX (0, numPol);
  out->numTabs = MAX (0, numTabs);
  out->revision = 3;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 3 + out->numBand*0 + out->numPol*8 + out->numTabs*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQ ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("TYPE_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("NTERM_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("X_TYP_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("Y_TYP_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("X_VAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("Y_VAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("GAIN_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("SENS_1");
    desc->FieldUnit[colNo] = g_strdup("K/JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("TYPE_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("NTERM_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("X_TYP_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("Y_TYP_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("X_VAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("Y_VAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("GAIN_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTabs;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("SENS_2");
    desc->FieldUnit[colNo] = g_strdup("K/JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableGCDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableGCOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableGCClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableGCValue */

/**
 * Convert an ObitTable to an ObitTableGC.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableGC* ObitTableGCConvert (ObitTable* in)
{
  ObitTableGC *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableGC(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableGCConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableGC* ObitTableGCCopy (ObitTableGC *in, ObitTableGC *out, ObitErr *err)
{
  gchar *routine = "ObitTableGCCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableGCClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableGC*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->numBand = in->numBand;
  out->numPol = in->numPol;
  out->numTabs = in->numTabs;
  out->revision = in->revision;
  /* Update class specific info */
  ObitTableGCUpdate (out, err);
    
  return out;
} /* end ObitTableGCCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableGCOpen (ObitTableGC *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableGCOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableGCClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableGCUpdate (in, err);
   
   return retCode;
} /* end ObitTableGCOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iGCRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableGCReadRow  (ObitTableGC *in, olong iGCRow, ObitTableGCRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableGCReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS GC Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iGCRow */
  retCode = ObitTableRead ((ObitTable*)in, iGCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->antennaNo = iRow[in->antennaNoOff];
  row->SubArray = iRow[in->SubArrayOff];
  row->FreqID = iRow[in->FreqIDOff];
  if (in->numPol>=1) row->Type1 = iRow + in->Type1Off;
  if (in->numPol>=1) row->NTerm1 = iRow + in->NTerm1Off;
  if (in->numPol>=1) row->XTyp1 = iRow + in->XTyp1Off;
  if (in->numPol>=1) row->YTyp1 = iRow + in->YTyp1Off;
  if (in->numPol>=1) row->XVal1 = fRow + in->XVal1Off;
  if (in->numPol>=1) row->YVal1 = fRow + in->YVal1Off;
  if (in->numPol>=1) row->gain1 = fRow + in->gain1Off;
  if (in->numPol>=1) row->sens1 = fRow + in->sens1Off;
  if (in->numPol>=2) row->Type2 = iRow + in->Type2Off;
  if (in->numPol>=2) row->NTerm2 = iRow + in->NTerm2Off;
  if (in->numPol>=2) row->XTyp2 = iRow + in->XTyp2Off;
  if (in->numPol>=2) row->YTyp2 = iRow + in->YTyp2Off;
  if (in->numPol>=2) row->XVal2 = fRow + in->XVal2Off;
  if (in->numPol>=2) row->YVal2 = fRow + in->YVal2Off;
  if (in->numPol>=2) row->gain2 = fRow + in->gain2Off;
  if (in->numPol>=2) row->sens2 = fRow + in->sens2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableGCReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableGCSetRow  (ObitTableGC *in, ObitTableGCRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "GC Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->Type1 = iRow + in->Type1Off;
  if (in->numPol>=1) row->NTerm1 = iRow + in->NTerm1Off;
  if (in->numPol>=1) row->XTyp1 = iRow + in->XTyp1Off;
  if (in->numPol>=1) row->YTyp1 = iRow + in->YTyp1Off;
  if (in->numPol>=1) row->XVal1 = fRow + in->XVal1Off;
  if (in->numPol>=1) row->YVal1 = fRow + in->YVal1Off;
  if (in->numPol>=1) row->gain1 = fRow + in->gain1Off;
  if (in->numPol>=1) row->sens1 = fRow + in->sens1Off;
  if (in->numPol>=2) row->Type2 = iRow + in->Type2Off;
  if (in->numPol>=2) row->NTerm2 = iRow + in->NTerm2Off;
  if (in->numPol>=2) row->XTyp2 = iRow + in->XTyp2Off;
  if (in->numPol>=2) row->YTyp2 = iRow + in->YTyp2Off;
  if (in->numPol>=2) row->XVal2 = fRow + in->XVal2Off;
  if (in->numPol>=2) row->YVal2 = fRow + in->YVal2Off;
  if (in->numPol>=2) row->gain2 = fRow + in->gain2Off;
  if (in->numPol>=2) row->sens2 = fRow + in->sens2Off;

} /*  end ObitTableGCSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableGCSetRow  
 * \param in       Table to read
 * \param iGCRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableGCWriteRow  (ObitTableGC *in, olong iGCRow, ObitTableGCRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableGCWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS GC Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->SubArrayOff] = row->SubArray;
  iRow[in->FreqIDOff] = row->FreqID;
  if (in->numPol>=1)
    if (in->Type1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Type1Col]; i++) 
        iRow[in->Type1Off+i] = row->Type1[i];
    } 
  if (in->numPol>=1)
    if (in->NTerm1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->NTerm1Col]; i++) 
        iRow[in->NTerm1Off+i] = row->NTerm1[i];
    } 
  if (in->numPol>=1)
    if (in->XTyp1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->XTyp1Col]; i++) 
        iRow[in->XTyp1Off+i] = row->XTyp1[i];
    } 
  if (in->numPol>=1)
    if (in->YTyp1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->YTyp1Col]; i++) 
        iRow[in->YTyp1Off+i] = row->YTyp1[i];
    } 
  if (in->numPol>=1)
    if (in->XVal1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->XVal1Col]; i++) 
        fRow[in->XVal1Off+i] = row->XVal1[i];
    } 
  if (in->numPol>=1)
    if (in->YVal1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->YVal1Col]; i++) 
        fRow[in->YVal1Off+i] = row->YVal1[i];
    } 
  if (in->numPol>=1)
    if (in->gain1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->gain1Col]; i++) 
        fRow[in->gain1Off+i] = row->gain1[i];
    } 
  if (in->numPol>=1)
    if (in->sens1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sens1Col]; i++) 
        fRow[in->sens1Off+i] = row->sens1[i];
    } 
  if (in->numPol>=2)
    if (in->Type2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Type2Col]; i++) 
        iRow[in->Type2Off+i] = row->Type2[i];
    } 
  if (in->numPol>=2)
    if (in->NTerm2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->NTerm2Col]; i++) 
        iRow[in->NTerm2Off+i] = row->NTerm2[i];
    } 
  if (in->numPol>=2)
    if (in->XTyp2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->XTyp2Col]; i++) 
        iRow[in->XTyp2Off+i] = row->XTyp2[i];
    } 
  if (in->numPol>=2)
    if (in->YTyp2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->YTyp2Col]; i++) 
        iRow[in->YTyp2Off+i] = row->YTyp2[i];
    } 
  if (in->numPol>=2)
    if (in->XVal2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->XVal2Col]; i++) 
        fRow[in->XVal2Off+i] = row->XVal2[i];
    } 
  if (in->numPol>=2)
    if (in->YVal2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->YVal2Col]; i++) 
        fRow[in->YVal2Off+i] = row->YVal2[i];
    } 
  if (in->numPol>=2)
    if (in->gain2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->gain2Col]; i++) 
        fRow[in->gain2Off+i] = row->gain2[i];
    } 
  if (in->numPol>=2)
    if (in->sens2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sens2Col]; i++) 
        fRow[in->sens2Off+i] = row->sens2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iGCRow */
  retCode = ObitTableWrite ((ObitTable*)in, iGCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableGCWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableGCClose (ObitTableGC *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableGCClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableGCDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableGCClose */

/*---------------Private functions--------------------------*/
/*----------------  TableGC Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableGCRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableGCRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->Type1 = NULL;
  in->NTerm1 = NULL;
  in->XTyp1 = NULL;
  in->YTyp1 = NULL;
  in->XVal1 = NULL;
  in->YVal1 = NULL;
  in->gain1 = NULL;
  in->sens1 = NULL;
  in->Type2 = NULL;
  in->NTerm2 = NULL;
  in->XTyp2 = NULL;
  in->YTyp2 = NULL;
  in->XVal2 = NULL;
  in->YVal2 = NULL;
  in->gain2 = NULL;
  in->sens2 = NULL;

} /* end ObitTableGCRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableGCRow* cast to an Obit*.
 */
void ObitTableGCRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableGCRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableGCRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableGCRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableGCRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableGCRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableGCRowClassInfoDefFn (gpointer inClass)
{
  ObitTableGCRowClassInfo *theClass = (ObitTableGCRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableGCRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableGCRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableGCRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableGCRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableGCRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableGCRowInit;

} /* end ObitTableGCRowClassDefFn */

/*------------------  TableGC  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableGCInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableGC *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableGCInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableGC* cast to an Obit*.
 */
void ObitTableGCClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableGC *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableGCClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableGCClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableGCClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableGCClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableGCClassInfoDefFn (gpointer inClass)
{
  ObitTableGCClassInfo *theClass = (ObitTableGCClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableGCClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableGCClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableGCGetClass;
  theClass->newObit       = (newObitFP)newObitTableGC;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableGCCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableGCClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableGCInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableGCConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableGCOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableGCClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableGCReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableGCWriteRow;

} /* end ObitTableGCClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableGCUpdate (ObitTableGC *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* numBand */
  if (!ObitInfoListGet(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand, err)) return;
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* numTabs */
  in->numTabs = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_TABS", &type, dim, 
		       (gpointer)&in->numTabs);
   /* revision */
  in->revision = 3; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);

  /* initialize column numbers/offsets */
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->SubArrayOff = -1;
  in->SubArrayCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->Type1Off = -1;
  in->Type1Col = -1;
  in->NTerm1Off = -1;
  in->NTerm1Col = -1;
  in->XTyp1Off = -1;
  in->XTyp1Col = -1;
  in->YTyp1Off = -1;
  in->YTyp1Col = -1;
  in->XVal1Off = -1;
  in->XVal1Col = -1;
  in->YVal1Off = -1;
  in->YVal1Col = -1;
  in->gain1Off = -1;
  in->gain1Col = -1;
  in->sens1Off = -1;
  in->sens1Col = -1;
  in->Type2Off = -1;
  in->Type2Col = -1;
  in->NTerm2Off = -1;
  in->NTerm2Col = -1;
  in->XTyp2Off = -1;
  in->XTyp2Col = -1;
  in->YTyp2Off = -1;
  in->YTyp2Col = -1;
  in->XVal2Off = -1;
  in->XVal2Col = -1;
  in->YVal2Off = -1;
  in->YVal2Col = -1;
  in->gain2Off = -1;
  in->gain2Col = -1;
  in->sens2Off = -1;
  in->sens2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY ", 9)) {
	 in->SubArrayOff = desc->offset[i];
 	 in->SubArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ ID  ", 9)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TYPE_1", 6)) {
	     in->Type1Off = desc->offset[i];
 	     in->Type1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "NTERM_1", 7)) {
	     in->NTerm1Off = desc->offset[i];
 	     in->NTerm1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_TYP_1", 7)) {
	     in->XTyp1Off = desc->offset[i];
 	     in->XTyp1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_TYP_1", 7)) {
	     in->YTyp1Off = desc->offset[i];
 	     in->YTyp1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_VAL_1", 7)) {
	     in->XVal1Off = desc->offset[i];
 	     in->XVal1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_VAL_1", 7)) {
	     in->YVal1Off = desc->offset[i];
 	     in->YVal1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GAIN_1", 6)) {
	     in->gain1Off = desc->offset[i];
 	     in->gain1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENS_1", 6)) {
	     in->sens1Off = desc->offset[i];
 	     in->sens1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "TYPE_2", 6)) {
	     in->Type2Off = desc->offset[i];
 	     in->Type2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "NTERM_2", 7)) {
	     in->NTerm2Off = desc->offset[i];
 	     in->NTerm2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_TYP_2", 7)) {
	     in->XTyp2Off = desc->offset[i];
 	     in->XTyp2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_TYP_2", 7)) {
	     in->YTyp2Off = desc->offset[i];
 	     in->YTyp2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "X_VAL_2", 7)) {
	     in->XVal2Off = desc->offset[i];
 	     in->XVal2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "Y_VAL_2", 7)) {
	     in->YVal2Off = desc->offset[i];
 	     in->YVal2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GAIN_2", 6)) {
	     in->gain2Off = desc->offset[i];
 	     in->gain2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENS_2", 6)) {
	     in->sens2Off = desc->offset[i];
 	     in->sens2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTableGCUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->SubArrayOff > -1), err,
       "ObitTableGCUpdate: Could not find column SubArray");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableGCUpdate: Could not find column FreqID");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->Type1Off > -1), err,
       "ObitTableGCUpdate: Could not find column Type1");
    Obit_return_if_fail((in->NTerm1Off > -1), err,
       "ObitTableGCUpdate: Could not find column NTerm1");
    Obit_return_if_fail((in->XTyp1Off > -1), err,
       "ObitTableGCUpdate: Could not find column XTyp1");
    Obit_return_if_fail((in->YTyp1Off > -1), err,
       "ObitTableGCUpdate: Could not find column YTyp1");
    Obit_return_if_fail((in->XVal1Off > -1), err,
       "ObitTableGCUpdate: Could not find column XVal1");
    Obit_return_if_fail((in->YVal1Off > -1), err,
       "ObitTableGCUpdate: Could not find column YVal1");
    Obit_return_if_fail((in->gain1Off > -1), err,
       "ObitTableGCUpdate: Could not find column gain1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->Type2Off > -1), err,
       "ObitTableGCUpdate: Could not find column Type2");
    Obit_return_if_fail((in->NTerm2Off > -1), err,
       "ObitTableGCUpdate: Could not find column NTerm2");
    Obit_return_if_fail((in->XTyp2Off > -1), err,
       "ObitTableGCUpdate: Could not find column XTyp2");
    Obit_return_if_fail((in->YTyp2Off > -1), err,
       "ObitTableGCUpdate: Could not find column YTyp2");
    Obit_return_if_fail((in->XVal2Off > -1), err,
       "ObitTableGCUpdate: Could not find column XVal2");
    Obit_return_if_fail((in->YVal2Off > -1), err,
       "ObitTableGCUpdate: Could not find column YVal2");
    Obit_return_if_fail((in->gain2Off > -1), err,
       "ObitTableGCUpdate: Could not find column gain2");
  } /* end of if index in range */
} /* end ObitTableGCUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableGCDumpKey (ObitTableGC *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* numTabs */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_TABS", type, dim, 
		  (gpointer)&in->numTabs);
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
   
} /* end ObitTableGCDumpKey */
