/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_BANDPASS.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_BANDPASS.c
 * ObitTableIDI_BANDPASS class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_BANDPASS";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_BANDPASSRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_BANDPASSRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_BANDPASSClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_BANDPASSClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_BANDPASSRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_BANDPASSRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_BANDPASSInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_BANDPASSClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_BANDPASSUpdate (ObitTableIDI_BANDPASS *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_BANDPASSDumpKey (ObitTableIDI_BANDPASS *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_BANDPASSClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_BANDPASSRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_BANDPASSRow* newObitTableIDI_BANDPASSRow (ObitTableIDI_BANDPASS *table)
{
  ObitTableIDI_BANDPASSRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_BANDPASSRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_BANDPASSRow));

  /* initialize values */
  out->name = g_strdup("TableIDI_BANDPASS Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_BANDPASSRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->bandwidth = fRow + table->bandwidthOff;
    out->band_freq = dRow + table->band_freqOff;
    if (table->numPol>=1) out->refant1 = iRow + table->refant1Off;
    if (table->numPol>=1) out->breal1 = fRow + table->breal1Off;
    if (table->numPol>=1) out->bimag1 = fRow + table->bimag1Off;
    if (table->numPol>=2) out->refant2 = iRow + table->refant2Off;
    if (table->numPol>=2) out->breal2 = fRow + table->breal2Off;
    if (table->numPol>=2) out->bimag2 = fRow + table->bimag2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_BANDPASSRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_BANDPASSRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_BANDPASSRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_BANDPASSRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_BANDPASS* newObitTableIDI_BANDPASS (gchar* name)
{
  ObitTableIDI_BANDPASS* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_BANDPASSClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_BANDPASS));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_BANDPASSInit((gpointer)out);

 return out;
} /* end newObitTableIDI_BANDPASS */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_BANDPASSGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_BANDPASSClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_BANDPASSGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations
 * \param no_band [OPTIONAL] Number of frequency bands
 * \param numAnt The maximum antenna number
 * \param numBach The number of spectral channels tabulated
 * \param strtChn Data channel number (1-rel) of first channel in the table
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_BANDPASS* newObitTableIDI_BANDPASSValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint no_band, oint numAnt, oint numBach, oint strtChn,
		     ObitErr *err)
{
  ObitTableIDI_BANDPASS* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "BANDPASS";
  gchar *routine = "newObitTableIDI_BANDPASSValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_BANDPASSClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "BANDPASS");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_BANDPASS */
      if (ObitTableIDI_BANDPASSIsA(testTab)) { /* it is an ObitTableIDI_BANDPASS */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_BANDPASSConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "BANDPASS");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_BANDPASSIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_BANDPASSConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->no_band = MAX (0, no_band);
  out->numAnt = MAX (0, numAnt);
  out->numBach = MAX (0, numBach);
  out->strtChn = MAX (0, strtChn);
  out->tabrev = 1;
  out->no_chan = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_BANDPASS );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 8 + out->numPol*3 + out->no_band*0 + out->numAnt*0 + out->numBach*0 + out->strtChn*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME_INTERVAL");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("BANDWIDTH");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("BAND_FREQ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REFANT_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("BREAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBach;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("BIMAG_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBach;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REFANT_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("BREAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBach;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("BIMAG_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBach;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_BANDPASSDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_BANDPASSOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_BANDPASSClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_BANDPASSValue */

/**
 * Convert an ObitTable to an ObitTableIDI_BANDPASS.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_BANDPASS* ObitTableIDI_BANDPASSConvert (ObitTable* in)
{
  ObitTableIDI_BANDPASS *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_BANDPASS(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_BANDPASSConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_BANDPASS* ObitTableIDI_BANDPASSCopy (ObitTableIDI_BANDPASS *in, ObitTableIDI_BANDPASS *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_BANDPASSCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_BANDPASSClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_BANDPASS*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->numPol = in->numPol;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->numAnt = in->numAnt;
  out->numBach = in->numBach;
  out->strtChn = in->strtChn;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_BANDPASS );
  /* Update class specific info */
  ObitTableIDI_BANDPASSUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_BANDPASSCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_BANDPASSOpen (ObitTableIDI_BANDPASS *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_BANDPASSOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_BANDPASSClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_BANDPASSUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_BANDPASSOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_BANDPASSRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_BANDPASSReadRow  (ObitTableIDI_BANDPASS *in, olong iIDI_BANDPASSRow, ObitTableIDI_BANDPASSRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_BANDPASSReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_BANDPASS Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_BANDPASSRow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_BANDPASSRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->SourID = iRow[in->SourIDOff];
  row->antNo = iRow[in->antNoOff];
  row->Array = iRow[in->ArrayOff];
  row->fqid = iRow[in->fqidOff];
  row->bandwidth = fRow + in->bandwidthOff;
  row->band_freq = dRow + in->band_freqOff;
  if (in->numPol>=1) row->refant1 = iRow + in->refant1Off;
  if (in->numPol>=1) row->breal1 = fRow + in->breal1Off;
  if (in->numPol>=1) row->bimag1 = fRow + in->bimag1Off;
  if (in->numPol>=2) row->refant2 = iRow + in->refant2Off;
  if (in->numPol>=2) row->breal2 = fRow + in->breal2Off;
  if (in->numPol>=2) row->bimag2 = fRow + in->bimag2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_BANDPASSReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_BANDPASSSetRow  (ObitTableIDI_BANDPASS *in, ObitTableIDI_BANDPASSRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_BANDPASS Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->bandwidth = fRow + in->bandwidthOff;
  row->band_freq = dRow + in->band_freqOff;
  if (in->numPol>=1) row->refant1 = iRow + in->refant1Off;
  if (in->numPol>=1) row->breal1 = fRow + in->breal1Off;
  if (in->numPol>=1) row->bimag1 = fRow + in->bimag1Off;
  if (in->numPol>=2) row->refant2 = iRow + in->refant2Off;
  if (in->numPol>=2) row->breal2 = fRow + in->breal2Off;
  if (in->numPol>=2) row->bimag2 = fRow + in->bimag2Off;

} /*  end ObitTableIDI_BANDPASSSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_BANDPASSSetRow  
 * \param in       Table to read
 * \param iIDI_BANDPASSRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_BANDPASSWriteRow  (ObitTableIDI_BANDPASS *in, olong iIDI_BANDPASSRow, ObitTableIDI_BANDPASSRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_BANDPASSWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_BANDPASS Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antNoOff] = row->antNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->fqidOff] = row->fqid;
  if (in->bandwidthCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->bandwidthCol]; i++) 
      fRow[in->bandwidthOff+i] = row->bandwidth[i];
  } 
  if (in->band_freqCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->band_freqCol]; i++) 
      dRow[in->band_freqOff+i] = row->band_freq[i];
  } 
  if (in->numPol>=1)
    if (in->refant1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->refant1Col]; i++) 
        iRow[in->refant1Off+i] = row->refant1[i];
    } 
  if (in->numPol>=1)
    if (in->breal1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->breal1Col]; i++) 
        fRow[in->breal1Off+i] = row->breal1[i];
    } 
  if (in->numPol>=1)
    if (in->bimag1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->bimag1Col]; i++) 
        fRow[in->bimag1Off+i] = row->bimag1[i];
    } 
  if (in->numPol>=2)
    if (in->refant2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->refant2Col]; i++) 
        iRow[in->refant2Off+i] = row->refant2[i];
    } 
  if (in->numPol>=2)
    if (in->breal2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->breal2Col]; i++) 
        fRow[in->breal2Off+i] = row->breal2[i];
    } 
  if (in->numPol>=2)
    if (in->bimag2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->bimag2Col]; i++) 
        fRow[in->bimag2Off+i] = row->bimag2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_BANDPASSRow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_BANDPASSRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_BANDPASSWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_BANDPASSClose (ObitTableIDI_BANDPASS *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_BANDPASSClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_BANDPASSDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_BANDPASSClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_BANDPASS Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_BANDPASSRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_BANDPASSRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->bandwidth = NULL;
  in->band_freq = NULL;
  in->refant1 = NULL;
  in->breal1 = NULL;
  in->bimag1 = NULL;
  in->refant2 = NULL;
  in->breal2 = NULL;
  in->bimag2 = NULL;

} /* end ObitTableIDI_BANDPASSRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_BANDPASSRow* cast to an Obit*.
 */
void ObitTableIDI_BANDPASSRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_BANDPASSRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_BANDPASSRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_BANDPASSRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_BANDPASSRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_BANDPASSRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_BANDPASSRowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_BANDPASSRowClassInfo *theClass = (ObitTableIDI_BANDPASSRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_BANDPASSRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_BANDPASSRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_BANDPASSRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_BANDPASSRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_BANDPASSRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_BANDPASSRowInit;

} /* end ObitTableIDI_BANDPASSRowClassDefFn */

/*------------------  TableIDI_BANDPASS  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_BANDPASSInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_BANDPASS *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_BANDPASSInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_BANDPASS* cast to an Obit*.
 */
void ObitTableIDI_BANDPASSClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_BANDPASS *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_BANDPASSClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_BANDPASSClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_BANDPASSClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_BANDPASSClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_BANDPASSClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_BANDPASSClassInfo *theClass = (ObitTableIDI_BANDPASSClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_BANDPASSClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_BANDPASSClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_BANDPASSGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_BANDPASS;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_BANDPASSCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_BANDPASSClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_BANDPASSInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_BANDPASSConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_BANDPASSOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_BANDPASSClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_BANDPASSReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_BANDPASSWriteRow;

} /* end ObitTableIDI_BANDPASSClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_BANDPASSUpdate (ObitTableIDI_BANDPASS *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
   /* numAnt */
  in->numAnt = 2; 
  ObitInfoListGetTest(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->numAnt);
   /* numBach */
  in->numBach = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BACH", &type, dim, 
		       (gpointer)&in->numBach);
   /* strtChn */
  in->strtChn = 1; 
  ObitInfoListGetTest(in->myDesc->info, "STRT_CHN", &type, dim, 
		       (gpointer)&in->strtChn);
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_BANDPASS); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->fqidOff = -1;
  in->fqidCol = -1;
  in->bandwidthOff = -1;
  in->bandwidthCol = -1;
  in->band_freqOff = -1;
  in->band_freqCol = -1;
  in->refant1Off = -1;
  in->refant1Col = -1;
  in->breal1Off = -1;
  in->breal1Col = -1;
  in->bimag1Off = -1;
  in->bimag1Col = -1;
  in->refant2Off = -1;
  in->refant2Col = -1;
  in->breal2Off = -1;
  in->breal2Col = -1;
  in->bimag2Off = -1;
  in->bimag2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_INTERVAL", 13)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID", 9)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY", 5)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->fqidOff = desc->offset[i];
 	 in->fqidCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BANDWIDTH", 9)) {
	 in->bandwidthOff = desc->offset[i];
 	 in->bandwidthCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BAND_FREQ", 9)) {
	 in->band_freqOff = desc->offset[i];
 	 in->band_freqCol = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT_1", 8)) {
	     in->refant1Off = desc->offset[i];
 	     in->refant1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "BREAL_1", 7)) {
	     in->breal1Off = desc->offset[i];
 	     in->breal1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "BIMAG_1", 7)) {
	     in->bimag1Off = desc->offset[i];
 	     in->bimag1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT_2", 8)) {
	     in->refant2Off = desc->offset[i];
 	     in->refant2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "BREAL_2", 7)) {
	     in->breal2Off = desc->offset[i];
 	     in->breal2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "BIMAG_2", 7)) {
	     in->bimag2Off = desc->offset[i];
 	     in->bimag2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column antNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column Array");
  Obit_return_if_fail((in->fqidOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column fqid");
  Obit_return_if_fail((in->bandwidthOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column bandwidth");
  Obit_return_if_fail((in->band_freqOff > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column band_freq");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->refant1Off > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column refant1");
    Obit_return_if_fail((in->breal1Off > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column breal1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->refant2Off > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column refant2");
    Obit_return_if_fail((in->breal2Off > -1), err,
       "ObitTableIDI_BANDPASSUpdate: Could not find column breal2");
  } /* end of if index in range */
} /* end ObitTableIDI_BANDPASSUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_BANDPASSDumpKey (ObitTableIDI_BANDPASS *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* numAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->numAnt);
  /* numBach */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BACH", type, dim, 
		  (gpointer)&in->numBach);
  /* strtChn */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STRT_CHN", type, dim, 
		  (gpointer)&in->strtChn);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_BANDPASS;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
   
} /* end ObitTableIDI_BANDPASSDumpKey */
