/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_CALIBRATION.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_CALIBRATION.c
 * ObitTableIDI_CALIBRATION class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_CALIBRATION";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_CALIBRATIONRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_CALIBRATIONRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_CALIBRATIONClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_CALIBRATIONClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_CALIBRATIONRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_CALIBRATIONRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_CALIBRATIONInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_CALIBRATIONClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_CALIBRATIONUpdate (ObitTableIDI_CALIBRATION *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_CALIBRATIONDumpKey (ObitTableIDI_CALIBRATION *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_CALIBRATIONClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_CALIBRATIONRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_CALIBRATIONRow* newObitTableIDI_CALIBRATIONRow (ObitTableIDI_CALIBRATION *table)
{
  ObitTableIDI_CALIBRATIONRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_CALIBRATIONRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_CALIBRATIONRow));

  /* initialize values */
  out->name = g_strdup("TableIDI_CALIBRATION Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_CALIBRATIONRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->TSys1 = fRow + table->TSys1Off;
    if (table->numPol>=1) out->TAnt1 = fRow + table->TAnt1Off;
    if (table->numPol>=1) out->sensitivity1 = fRow + table->sensitivity1Off;
    if (table->numPol>=1) out->phase1 = fRow + table->phase1Off;
    if (table->numPol>=1) out->rate1 = fRow + table->rate1Off;
    if (table->numPol>=1) out->delay1 = fRow + table->delay1Off;
    if (table->numPol>=1) out->real1 = fRow + table->real1Off;
    if (table->numPol>=1) out->imag1 = fRow + table->imag1Off;
    if (table->numPol>=1) out->weight1 = fRow + table->weight1Off;
    if (table->numPol>=1) out->refant1 = iRow + table->refant1Off;
    if (table->numPol>=2) out->TSys2 = fRow + table->TSys2Off;
    if (table->numPol>=2) out->TAnt2 = fRow + table->TAnt2Off;
    if (table->numPol>=2) out->sensitivity2 = fRow + table->sensitivity2Off;
    if (table->numPol>=2) out->phase2 = fRow + table->phase2Off;
    if (table->numPol>=2) out->rate2 = fRow + table->rate2Off;
    if (table->numPol>=2) out->delay2 = fRow + table->delay2Off;
    if (table->numPol>=2) out->real2 = fRow + table->real2Off;
    if (table->numPol>=2) out->imag2 = fRow + table->imag2Off;
    if (table->numPol>=2) out->weight2 = fRow + table->weight2Off;
    if (table->numPol>=2) out->refant2 = iRow + table->refant2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_CALIBRATIONRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_CALIBRATIONRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_CALIBRATIONRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_CALIBRATIONRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_CALIBRATION* newObitTableIDI_CALIBRATION (gchar* name)
{
  ObitTableIDI_CALIBRATION* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_CALIBRATIONClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_CALIBRATION));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_CALIBRATIONInit((gpointer)out);

 return out;
} /* end newObitTableIDI_CALIBRATION */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_CALIBRATIONGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_CALIBRATIONClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_CALIBRATIONGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations
 * \param no_band [OPTIONAL] Number of frequency bands
 * \param numAnt The maximum antenna number
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_CALIBRATION* newObitTableIDI_CALIBRATIONValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint no_band, oint numAnt,
		     ObitErr *err)
{
  ObitTableIDI_CALIBRATION* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "CALIBRATION";
  gchar *routine = "newObitTableIDI_CALIBRATIONValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_CALIBRATIONClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "CALIBRATION");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_CALIBRATION */
      if (ObitTableIDI_CALIBRATIONIsA(testTab)) { /* it is an ObitTableIDI_CALIBRATION */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_CALIBRATIONConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "CALIBRATION");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_CALIBRATIONIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_CALIBRATIONConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->no_band = MAX (0, no_band);
  out->numAnt = MAX (0, numAnt);
  out->tabrev = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->no_chan = 1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_CALIBRATION );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 6 + out->numPol*10 + out->no_band*0 + out->numAnt*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME_INTERVAL");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("TSYS_1");
    desc->FieldUnit[colNo] = g_strdup("K");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("TANT_1");
    desc->FieldUnit[colNo] = g_strdup("K");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("SENSITIVITY_1");
    desc->FieldUnit[colNo] = g_strdup("K/JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PHASE_1");
    desc->FieldUnit[colNo] = g_strdup("RAD");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("RATE_1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DELAY_1");
    desc->FieldUnit[colNo] = g_strdup("SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("IMAG_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("WEIGHT_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("REFANT_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("TSYS_2");
    desc->FieldUnit[colNo] = g_strdup("K");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("TANT_2");
    desc->FieldUnit[colNo] = g_strdup("K");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("SENSITIVITY_2");
    desc->FieldUnit[colNo] = g_strdup("K/JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PHASE_2");
    desc->FieldUnit[colNo] = g_strdup("RAD");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("RATE_2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DELAY_2");
    desc->FieldUnit[colNo] = g_strdup("SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("IMAG_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("WEIGHT_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("REFANT_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_CALIBRATIONDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_CALIBRATIONOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_CALIBRATIONClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_CALIBRATIONValue */

/**
 * Convert an ObitTable to an ObitTableIDI_CALIBRATION.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_CALIBRATION* ObitTableIDI_CALIBRATIONConvert (ObitTable* in)
{
  ObitTableIDI_CALIBRATION *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_CALIBRATION(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_CALIBRATIONConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_CALIBRATION* ObitTableIDI_CALIBRATIONCopy (ObitTableIDI_CALIBRATION *in, ObitTableIDI_CALIBRATION *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_CALIBRATIONCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_CALIBRATIONClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_CALIBRATION*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->numPol = in->numPol;
  out->no_band = in->no_band;
  out->numAnt = in->numAnt;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->no_chan = in->no_chan;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_CALIBRATION );
  /* Update class specific info */
  ObitTableIDI_CALIBRATIONUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_CALIBRATIONCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_CALIBRATIONOpen (ObitTableIDI_CALIBRATION *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_CALIBRATIONOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_CALIBRATIONClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_CALIBRATIONUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_CALIBRATIONOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_CALIBRATIONRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_CALIBRATIONReadRow  (ObitTableIDI_CALIBRATION *in, olong iIDI_CALIBRATIONRow, ObitTableIDI_CALIBRATIONRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_CALIBRATIONReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_CALIBRATION Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_CALIBRATIONRow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_CALIBRATIONRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->SourID = iRow[in->SourIDOff];
  row->antNo = iRow[in->antNoOff];
  row->Array = iRow[in->ArrayOff];
  row->fqid = iRow[in->fqidOff];
  if (in->numPol>=1) row->TSys1 = fRow + in->TSys1Off;
  if (in->numPol>=1) row->TAnt1 = fRow + in->TAnt1Off;
  if (in->numPol>=1) row->sensitivity1 = fRow + in->sensitivity1Off;
  if (in->numPol>=1) row->phase1 = fRow + in->phase1Off;
  if (in->numPol>=1) row->rate1 = fRow + in->rate1Off;
  if (in->numPol>=1) row->delay1 = fRow + in->delay1Off;
  if (in->numPol>=1) row->real1 = fRow + in->real1Off;
  if (in->numPol>=1) row->imag1 = fRow + in->imag1Off;
  if (in->numPol>=1) row->weight1 = fRow + in->weight1Off;
  if (in->numPol>=1) row->refant1 = iRow + in->refant1Off;
  if (in->numPol>=2) row->TSys2 = fRow + in->TSys2Off;
  if (in->numPol>=2) row->TAnt2 = fRow + in->TAnt2Off;
  if (in->numPol>=2) row->sensitivity2 = fRow + in->sensitivity2Off;
  if (in->numPol>=2) row->phase2 = fRow + in->phase2Off;
  if (in->numPol>=2) row->rate2 = fRow + in->rate2Off;
  if (in->numPol>=2) row->delay2 = fRow + in->delay2Off;
  if (in->numPol>=2) row->real2 = fRow + in->real2Off;
  if (in->numPol>=2) row->imag2 = fRow + in->imag2Off;
  if (in->numPol>=2) row->weight2 = fRow + in->weight2Off;
  if (in->numPol>=2) row->refant2 = iRow + in->refant2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_CALIBRATIONReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_CALIBRATIONSetRow  (ObitTableIDI_CALIBRATION *in, ObitTableIDI_CALIBRATIONRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_CALIBRATION Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->TSys1 = fRow + in->TSys1Off;
  if (in->numPol>=1) row->TAnt1 = fRow + in->TAnt1Off;
  if (in->numPol>=1) row->sensitivity1 = fRow + in->sensitivity1Off;
  if (in->numPol>=1) row->phase1 = fRow + in->phase1Off;
  if (in->numPol>=1) row->rate1 = fRow + in->rate1Off;
  if (in->numPol>=1) row->delay1 = fRow + in->delay1Off;
  if (in->numPol>=1) row->real1 = fRow + in->real1Off;
  if (in->numPol>=1) row->imag1 = fRow + in->imag1Off;
  if (in->numPol>=1) row->weight1 = fRow + in->weight1Off;
  if (in->numPol>=1) row->refant1 = iRow + in->refant1Off;
  if (in->numPol>=2) row->TSys2 = fRow + in->TSys2Off;
  if (in->numPol>=2) row->TAnt2 = fRow + in->TAnt2Off;
  if (in->numPol>=2) row->sensitivity2 = fRow + in->sensitivity2Off;
  if (in->numPol>=2) row->phase2 = fRow + in->phase2Off;
  if (in->numPol>=2) row->rate2 = fRow + in->rate2Off;
  if (in->numPol>=2) row->delay2 = fRow + in->delay2Off;
  if (in->numPol>=2) row->real2 = fRow + in->real2Off;
  if (in->numPol>=2) row->imag2 = fRow + in->imag2Off;
  if (in->numPol>=2) row->weight2 = fRow + in->weight2Off;
  if (in->numPol>=2) row->refant2 = iRow + in->refant2Off;

} /*  end ObitTableIDI_CALIBRATIONSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_CALIBRATIONSetRow  
 * \param in       Table to read
 * \param iIDI_CALIBRATIONRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_CALIBRATIONWriteRow  (ObitTableIDI_CALIBRATION *in, olong iIDI_CALIBRATIONRow, ObitTableIDI_CALIBRATIONRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_CALIBRATIONWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_CALIBRATION Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antNoOff] = row->antNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->fqidOff] = row->fqid;
  if (in->numPol>=1)
    if (in->TSys1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->TSys1Col]; i++) 
        fRow[in->TSys1Off+i] = row->TSys1[i];
    } 
  if (in->numPol>=1)
    if (in->TAnt1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->TAnt1Col]; i++) 
        fRow[in->TAnt1Off+i] = row->TAnt1[i];
    } 
  if (in->numPol>=1)
    if (in->sensitivity1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sensitivity1Col]; i++) 
        fRow[in->sensitivity1Off+i] = row->sensitivity1[i];
    } 
  if (in->numPol>=1)
    if (in->phase1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->phase1Col]; i++) 
        fRow[in->phase1Off+i] = row->phase1[i];
    } 
  if (in->numPol>=1)
    if (in->rate1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->rate1Col]; i++) 
        fRow[in->rate1Off+i] = row->rate1[i];
    } 
  if (in->numPol>=1)
    if (in->delay1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->delay1Col]; i++) 
        fRow[in->delay1Off+i] = row->delay1[i];
    } 
  if (in->numPol>=1)
    if (in->real1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->real1Col]; i++) 
        fRow[in->real1Off+i] = row->real1[i];
    } 
  if (in->numPol>=1)
    if (in->imag1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->imag1Col]; i++) 
        fRow[in->imag1Off+i] = row->imag1[i];
    } 
  if (in->numPol>=1)
    if (in->weight1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->weight1Col]; i++) 
        fRow[in->weight1Off+i] = row->weight1[i];
    } 
  if (in->numPol>=1)
    if (in->refant1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->refant1Col]; i++) 
        iRow[in->refant1Off+i] = row->refant1[i];
    } 
  if (in->numPol>=2)
    if (in->TSys2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->TSys2Col]; i++) 
        fRow[in->TSys2Off+i] = row->TSys2[i];
    } 
  if (in->numPol>=2)
    if (in->TAnt2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->TAnt2Col]; i++) 
        fRow[in->TAnt2Off+i] = row->TAnt2[i];
    } 
  if (in->numPol>=2)
    if (in->sensitivity2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->sensitivity2Col]; i++) 
        fRow[in->sensitivity2Off+i] = row->sensitivity2[i];
    } 
  if (in->numPol>=2)
    if (in->phase2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->phase2Col]; i++) 
        fRow[in->phase2Off+i] = row->phase2[i];
    } 
  if (in->numPol>=2)
    if (in->rate2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->rate2Col]; i++) 
        fRow[in->rate2Off+i] = row->rate2[i];
    } 
  if (in->numPol>=2)
    if (in->delay2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->delay2Col]; i++) 
        fRow[in->delay2Off+i] = row->delay2[i];
    } 
  if (in->numPol>=2)
    if (in->real2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->real2Col]; i++) 
        fRow[in->real2Off+i] = row->real2[i];
    } 
  if (in->numPol>=2)
    if (in->imag2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->imag2Col]; i++) 
        fRow[in->imag2Off+i] = row->imag2[i];
    } 
  if (in->numPol>=2)
    if (in->weight2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->weight2Col]; i++) 
        fRow[in->weight2Off+i] = row->weight2[i];
    } 
  if (in->numPol>=2)
    if (in->refant2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->refant2Col]; i++) 
        iRow[in->refant2Off+i] = row->refant2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_CALIBRATIONRow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_CALIBRATIONRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_CALIBRATIONWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_CALIBRATIONClose (ObitTableIDI_CALIBRATION *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_CALIBRATIONClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_CALIBRATIONDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_CALIBRATIONClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_CALIBRATION Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_CALIBRATIONRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_CALIBRATIONRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->TSys1 = NULL;
  in->TAnt1 = NULL;
  in->sensitivity1 = NULL;
  in->phase1 = NULL;
  in->rate1 = NULL;
  in->delay1 = NULL;
  in->real1 = NULL;
  in->imag1 = NULL;
  in->weight1 = NULL;
  in->refant1 = NULL;
  in->TSys2 = NULL;
  in->TAnt2 = NULL;
  in->sensitivity2 = NULL;
  in->phase2 = NULL;
  in->rate2 = NULL;
  in->delay2 = NULL;
  in->real2 = NULL;
  in->imag2 = NULL;
  in->weight2 = NULL;
  in->refant2 = NULL;

} /* end ObitTableIDI_CALIBRATIONRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_CALIBRATIONRow* cast to an Obit*.
 */
void ObitTableIDI_CALIBRATIONRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_CALIBRATIONRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_CALIBRATIONRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_CALIBRATIONRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_CALIBRATIONRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_CALIBRATIONRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_CALIBRATIONRowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_CALIBRATIONRowClassInfo *theClass = (ObitTableIDI_CALIBRATIONRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_CALIBRATIONRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_CALIBRATIONRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_CALIBRATIONRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_CALIBRATIONRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_CALIBRATIONRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_CALIBRATIONRowInit;

} /* end ObitTableIDI_CALIBRATIONRowClassDefFn */

/*------------------  TableIDI_CALIBRATION  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_CALIBRATIONInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_CALIBRATION *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_CALIBRATIONInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_CALIBRATION* cast to an Obit*.
 */
void ObitTableIDI_CALIBRATIONClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_CALIBRATION *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_CALIBRATIONClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_CALIBRATIONClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_CALIBRATIONClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_CALIBRATIONClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_CALIBRATIONClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_CALIBRATIONClassInfo *theClass = (ObitTableIDI_CALIBRATIONClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_CALIBRATIONClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_CALIBRATIONClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_CALIBRATIONGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_CALIBRATION;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_CALIBRATIONCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_CALIBRATIONClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_CALIBRATIONInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_CALIBRATIONConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_CALIBRATIONOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_CALIBRATIONClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_CALIBRATIONReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_CALIBRATIONWriteRow;

} /* end ObitTableIDI_CALIBRATIONClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_CALIBRATIONUpdate (ObitTableIDI_CALIBRATION *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* numAnt */
  if (!ObitInfoListGet(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->numAnt, err)) return;
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_CALIBRATION); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->fqidOff = -1;
  in->fqidCol = -1;
  in->TSys1Off = -1;
  in->TSys1Col = -1;
  in->TAnt1Off = -1;
  in->TAnt1Col = -1;
  in->sensitivity1Off = -1;
  in->sensitivity1Col = -1;
  in->phase1Off = -1;
  in->phase1Col = -1;
  in->rate1Off = -1;
  in->rate1Col = -1;
  in->delay1Off = -1;
  in->delay1Col = -1;
  in->real1Off = -1;
  in->real1Col = -1;
  in->imag1Off = -1;
  in->imag1Col = -1;
  in->weight1Off = -1;
  in->weight1Col = -1;
  in->refant1Off = -1;
  in->refant1Col = -1;
  in->TSys2Off = -1;
  in->TSys2Col = -1;
  in->TAnt2Off = -1;
  in->TAnt2Col = -1;
  in->sensitivity2Off = -1;
  in->sensitivity2Col = -1;
  in->phase2Off = -1;
  in->phase2Col = -1;
  in->rate2Off = -1;
  in->rate2Col = -1;
  in->delay2Off = -1;
  in->delay2Col = -1;
  in->real2Off = -1;
  in->real2Col = -1;
  in->imag2Off = -1;
  in->imag2Col = -1;
  in->weight2Off = -1;
  in->weight2Col = -1;
  in->refant2Off = -1;
  in->refant2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_INTERVAL", 13)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID", 9)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY", 5)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->fqidOff = desc->offset[i];
 	 in->fqidCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TSYS_1", 6)) {
	     in->TSys1Off = desc->offset[i];
 	     in->TSys1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "TANT_1", 6)) {
	     in->TAnt1Off = desc->offset[i];
 	     in->TAnt1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENSITIVITY_1", 13)) {
	     in->sensitivity1Off = desc->offset[i];
 	     in->sensitivity1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PHASE_1", 7)) {
	     in->phase1Off = desc->offset[i];
 	     in->phase1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "RATE_1", 6)) {
	     in->rate1Off = desc->offset[i];
 	     in->rate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DELAY_1", 7)) {
	     in->delay1Off = desc->offset[i];
 	     in->delay1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL_1", 6)) {
	     in->real1Off = desc->offset[i];
 	     in->real1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG_1", 6)) {
	     in->imag1Off = desc->offset[i];
 	     in->imag1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT_1", 8)) {
	     in->weight1Off = desc->offset[i];
 	     in->weight1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT_1", 8)) {
	     in->refant1Off = desc->offset[i];
 	     in->refant1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "TSYS_2", 6)) {
	     in->TSys2Off = desc->offset[i];
 	     in->TSys2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "TANT_2", 6)) {
	     in->TAnt2Off = desc->offset[i];
 	     in->TAnt2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "SENSITIVITY_2", 13)) {
	     in->sensitivity2Off = desc->offset[i];
 	     in->sensitivity2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PHASE_2", 7)) {
	     in->phase2Off = desc->offset[i];
 	     in->phase2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "RATE_2", 6)) {
	     in->rate2Off = desc->offset[i];
 	     in->rate2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DELAY_2", 7)) {
	     in->delay2Off = desc->offset[i];
 	     in->delay2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REAL_2", 6)) {
	     in->real2Off = desc->offset[i];
 	     in->real2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "IMAG_2", 6)) {
	     in->imag2Off = desc->offset[i];
 	     in->imag2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "WEIGHT_2", 8)) {
	     in->weight2Off = desc->offset[i];
 	     in->weight2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "REFANT_2", 8)) {
	     in->refant2Off = desc->offset[i];
 	     in->refant2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column antNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column Array");
  Obit_return_if_fail((in->fqidOff > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column fqid");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->TSys1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column TSys1");
    Obit_return_if_fail((in->TAnt1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column TAnt1");
    Obit_return_if_fail((in->sensitivity1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column sensitivity1");
    Obit_return_if_fail((in->phase1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column phase1");
    Obit_return_if_fail((in->rate1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column rate1");
    Obit_return_if_fail((in->delay1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column delay1");
    Obit_return_if_fail((in->real1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column real1");
    Obit_return_if_fail((in->imag1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column imag1");
    Obit_return_if_fail((in->weight1Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column weight1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->TSys2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column TSys2");
    Obit_return_if_fail((in->TAnt2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column TAnt2");
    Obit_return_if_fail((in->sensitivity2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column sensitivity2");
    Obit_return_if_fail((in->phase2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column phase2");
    Obit_return_if_fail((in->rate2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column rate2");
    Obit_return_if_fail((in->delay2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column delay2");
    Obit_return_if_fail((in->real2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column real2");
    Obit_return_if_fail((in->imag2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column imag2");
    Obit_return_if_fail((in->weight2Off > -1), err,
       "ObitTableIDI_CALIBRATIONUpdate: Could not find column weight2");
  } /* end of if index in range */
} /* end ObitTableIDI_CALIBRATIONUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_CALIBRATIONDumpKey (ObitTableIDI_CALIBRATION *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* numAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->numAnt);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_CALIBRATION;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
   
} /* end ObitTableIDI_CALIBRATIONDumpKey */
