/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTablePS.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTablePS.c
 * ObitTablePS class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTablePS";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTablePSRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePSRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTablePSClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePSClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTablePSRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTablePSRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTablePSInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTablePSClear (gpointer in);

/** Private: update table specific info */
static void ObitTablePSUpdate (ObitTablePS *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTablePSDumpKey (ObitTablePS *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTablePSClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTablePSRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePSRow* newObitTablePSRow (ObitTablePS *table)
{
  ObitTablePSRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePSRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePSRow));

  /* initialize values */
  out->name = g_strdup("TablePS Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTablePSRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->FieldName = cRow + table->FieldNameOff;
    out->obsdate = cRow + table->obsdateOff;
    out->Status = cRow + table->StatusOff;
    out->IQU = lRow + table->IQUOff;
    out->CCLimit = lRow + table->CCLimitOff;
    out->PerCent = fRow + table->PerCentOff;
    out->PixMax = fRow + table->PixMaxOff;
    out->PixMin = fRow + table->PixMinOff;
    out->Quality = fRow + table->QualityOff;
    out->Comment = cRow + table->CommentOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTablePSRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTablePSRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePSRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTablePSRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePS* newObitTablePS (gchar* name)
{
  ObitTablePS* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePSClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePS));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTablePSInit((gpointer)out);

 return out;
} /* end newObitTablePS */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTablePSGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePSClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitPSGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTablePS* newObitTablePSValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		    
		     ObitErr *err)
{
  ObitTablePS* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS PS";
  gchar *routine = "newObitTablePSValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePSClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS PS");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTablePS */
      if (ObitTablePSIsA(testTab)) { /* it is an ObitTablePS */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTablePSConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS PS");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTablePSIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTablePSConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->revision = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 14 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  optional = FALSE;
  if ((16 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FIELD NAME    ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 16;
    colNo++;
  }
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("OBSDATE ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("RA POINT ");
  desc->FieldUnit[colNo] = g_strdup("DEG");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DEC POINT");
  desc->FieldUnit[colNo] = g_strdup("DEG");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("STATUS   ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("IQU      ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_bool;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("SPECIAL  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_bool;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("NO. FIELDS");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("CC LIMIT  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_bool;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("PERCENT  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("PIX MAX  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("PIX MIN  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((3 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("QUALITY  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 3;
    colNo++;
  }
  optional = FALSE;
  if ((80 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("COMMENTS ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 80;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTablePSDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTablePSOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTablePSClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTablePSValue */

/**
 * Convert an ObitTable to an ObitTablePS.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTablePS* ObitTablePSConvert (ObitTable* in)
{
  ObitTablePS *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTablePS(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTablePSConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTablePS* ObitTablePSCopy (ObitTablePS *in, ObitTablePS *out, ObitErr *err)
{
  gchar *routine = "ObitTablePSCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePSClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTablePS*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  /* Update class specific info */
  ObitTablePSUpdate (out, err);
    
  return out;
} /* end ObitTablePSCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePSOpen (ObitTablePS *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTablePSOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePSClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTablePSUpdate (in, err);
   
   return retCode;
} /* end ObitTablePSOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iPSRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePSReadRow  (ObitTablePS *in, olong iPSRow, ObitTablePSRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePSReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PS Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iPSRow */
  retCode = ObitTableRead ((ObitTable*)in, iPSRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->RAPoint = dRow[in->RAPointOff];
  row->DecPoint = dRow[in->DecPointOff];
  row->Special = lRow[in->SpecialOff];
  row->NoFields = iRow[in->NoFieldsOff];
  row->FieldName = cRow + in->FieldNameOff;
  row->obsdate = cRow + in->obsdateOff;
  row->Status = cRow + in->StatusOff;
  row->IQU = lRow + in->IQUOff;
  row->CCLimit = lRow + in->CCLimitOff;
  row->PerCent = fRow + in->PerCentOff;
  row->PixMax = fRow + in->PixMaxOff;
  row->PixMin = fRow + in->PixMinOff;
  row->Quality = fRow + in->QualityOff;
  row->Comment = cRow + in->CommentOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTablePSReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTablePSSetRow  (ObitTablePS *in, ObitTablePSRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "PS Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->FieldName = cRow + in->FieldNameOff;
  row->obsdate = cRow + in->obsdateOff;
  row->Status = cRow + in->StatusOff;
  row->IQU = lRow + in->IQUOff;
  row->CCLimit = lRow + in->CCLimitOff;
  row->PerCent = fRow + in->PerCentOff;
  row->PixMax = fRow + in->PixMaxOff;
  row->PixMin = fRow + in->PixMinOff;
  row->Quality = fRow + in->QualityOff;
  row->Comment = cRow + in->CommentOff;

} /*  end ObitTablePSSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTablePSSetRow  
 * \param in       Table to read
 * \param iPSRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePSWriteRow  (ObitTablePS *in, olong iPSRow, ObitTablePSRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePSWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PS Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->RAPointOff] = row->RAPoint;
  dRow[in->DecPointOff] = row->DecPoint;
  lRow[in->SpecialOff] = row->Special;
  iRow[in->NoFieldsOff] = row->NoFields;
  if (in->FieldNameCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FieldNameCol]; i++) 
      cRow[in->FieldNameOff+i] = row->FieldName[i];
  } 
  if (in->obsdateCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->obsdateCol]; i++) 
      cRow[in->obsdateOff+i] = row->obsdate[i];
  } 
  if (in->StatusCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->StatusCol]; i++) 
      cRow[in->StatusOff+i] = row->Status[i];
  } 
  if (in->IQUCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->IQUCol]; i++) 
      lRow[in->IQUOff+i] = row->IQU[i];
  } 
  if (in->CCLimitCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->CCLimitCol]; i++) 
      lRow[in->CCLimitOff+i] = row->CCLimit[i];
  } 
  if (in->PerCentCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PerCentCol]; i++) 
      fRow[in->PerCentOff+i] = row->PerCent[i];
  } 
  if (in->PixMaxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PixMaxCol]; i++) 
      fRow[in->PixMaxOff+i] = row->PixMax[i];
  } 
  if (in->PixMinCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PixMinCol]; i++) 
      fRow[in->PixMinOff+i] = row->PixMin[i];
  } 
  if (in->QualityCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->QualityCol]; i++) 
      fRow[in->QualityOff+i] = row->Quality[i];
  } 
  if (in->CommentCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->CommentCol]; i++) 
      cRow[in->CommentOff+i] = row->Comment[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iPSRow */
  retCode = ObitTableWrite ((ObitTable*)in, iPSRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTablePSWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePSClose (ObitTablePS *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTablePSClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTablePSDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTablePSClose */

/*---------------Private functions--------------------------*/
/*----------------  TablePS Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePSRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePSRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->FieldName = NULL;
  in->obsdate = NULL;
  in->Status = NULL;
  in->IQU = NULL;
  in->CCLimit = NULL;
  in->PerCent = NULL;
  in->PixMax = NULL;
  in->PixMin = NULL;
  in->Quality = NULL;
  in->Comment = NULL;

} /* end ObitTablePSRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePSRow* cast to an Obit*.
 */
void ObitTablePSRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePSRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePSRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePSRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTablePSRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePSRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePSRowClassInfoDefFn (gpointer inClass)
{
  ObitTablePSRowClassInfo *theClass = (ObitTablePSRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePSRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePSRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePSRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTablePSRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTablePSRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTablePSRowInit;

} /* end ObitTablePSRowClassDefFn */

/*------------------  TablePS  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePSInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePS *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTablePSInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePS* cast to an Obit*.
 */
void ObitTablePSClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePS *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePSClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePSClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTablePSClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePSClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePSClassInfoDefFn (gpointer inClass)
{
  ObitTablePSClassInfo *theClass = (ObitTablePSClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePSClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePSClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePSGetClass;
  theClass->newObit       = (newObitFP)newObitTablePS;
  theClass->ObitCopy      = (ObitCopyFP)ObitTablePSCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTablePSClear;
  theClass->ObitInit      = (ObitInitFP)ObitTablePSInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTablePSConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTablePSOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTablePSClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTablePSReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTablePSWriteRow;

} /* end ObitTablePSClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePSUpdate (ObitTablePS *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "REVISION", &type, dim, 
		       (gpointer)&in->revision);

  /* initialize column numbers/offsets */
  in->FieldNameOff = -1;
  in->FieldNameCol = -1;
  in->obsdateOff = -1;
  in->obsdateCol = -1;
  in->RAPointOff = -1;
  in->RAPointCol = -1;
  in->DecPointOff = -1;
  in->DecPointCol = -1;
  in->StatusOff = -1;
  in->StatusCol = -1;
  in->IQUOff = -1;
  in->IQUCol = -1;
  in->SpecialOff = -1;
  in->SpecialCol = -1;
  in->NoFieldsOff = -1;
  in->NoFieldsCol = -1;
  in->CCLimitOff = -1;
  in->CCLimitCol = -1;
  in->PerCentOff = -1;
  in->PerCentCol = -1;
  in->PixMaxOff = -1;
  in->PixMaxCol = -1;
  in->PixMinOff = -1;
  in->PixMinCol = -1;
  in->QualityOff = -1;
  in->QualityCol = -1;
  in->CommentOff = -1;
  in->CommentCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "FIELD NAME    ", 14)) {
	 in->FieldNameOff = desc->offset[i];
 	 in->FieldNameCol = i;
      }
      if (!strncmp (desc->FieldName[i], "OBSDATE ", 8)) {
	 in->obsdateOff = desc->offset[i];
 	 in->obsdateCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RA POINT ", 9)) {
	 in->RAPointOff = desc->offset[i];
 	 in->RAPointCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DEC POINT", 9)) {
	 in->DecPointOff = desc->offset[i];
 	 in->DecPointCol = i;
      }
      if (!strncmp (desc->FieldName[i], "STATUS   ", 9)) {
	 in->StatusOff = desc->offset[i];
 	 in->StatusCol = i;
      }
      if (!strncmp (desc->FieldName[i], "IQU      ", 9)) {
	 in->IQUOff = desc->offset[i];
 	 in->IQUCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SPECIAL  ", 9)) {
	 in->SpecialOff = desc->offset[i];
 	 in->SpecialCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NO. FIELDS", 10)) {
	 in->NoFieldsOff = desc->offset[i];
 	 in->NoFieldsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CC LIMIT  ", 10)) {
	 in->CCLimitOff = desc->offset[i];
 	 in->CCLimitCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PERCENT  ", 9)) {
	 in->PerCentOff = desc->offset[i];
 	 in->PerCentCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PIX MAX  ", 9)) {
	 in->PixMaxOff = desc->offset[i];
 	 in->PixMaxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PIX MIN  ", 9)) {
	 in->PixMinOff = desc->offset[i];
 	 in->PixMinCol = i;
      }
      if (!strncmp (desc->FieldName[i], "QUALITY  ", 9)) {
	 in->QualityOff = desc->offset[i];
 	 in->QualityCol = i;
      }
      if (!strncmp (desc->FieldName[i], "COMMENTS ", 9)) {
	 in->CommentOff = desc->offset[i];
 	 in->CommentCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->FieldNameOff > -1), err,
       "ObitTablePSUpdate: Could not find column FieldName");
  Obit_return_if_fail((in->obsdateOff > -1), err,
       "ObitTablePSUpdate: Could not find column obsdate");
  Obit_return_if_fail((in->RAPointOff > -1), err,
       "ObitTablePSUpdate: Could not find column RAPoint");
  Obit_return_if_fail((in->DecPointOff > -1), err,
       "ObitTablePSUpdate: Could not find column DecPoint");
  Obit_return_if_fail((in->StatusOff > -1), err,
       "ObitTablePSUpdate: Could not find column Status");
  Obit_return_if_fail((in->IQUOff > -1), err,
       "ObitTablePSUpdate: Could not find column IQU");
  Obit_return_if_fail((in->SpecialOff > -1), err,
       "ObitTablePSUpdate: Could not find column Special");
  Obit_return_if_fail((in->NoFieldsOff > -1), err,
       "ObitTablePSUpdate: Could not find column NoFields");
  Obit_return_if_fail((in->CCLimitOff > -1), err,
       "ObitTablePSUpdate: Could not find column CCLimit");
  Obit_return_if_fail((in->PerCentOff > -1), err,
       "ObitTablePSUpdate: Could not find column PerCent");
  Obit_return_if_fail((in->PixMaxOff > -1), err,
       "ObitTablePSUpdate: Could not find column PixMax");
  Obit_return_if_fail((in->PixMinOff > -1), err,
       "ObitTablePSUpdate: Could not find column PixMin");
  Obit_return_if_fail((in->QualityOff > -1), err,
       "ObitTablePSUpdate: Could not find column Quality");
} /* end ObitTablePSUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePSDumpKey (ObitTablePS *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REVISION", type, dim, 
		  (gpointer)&in->revision);
   
} /* end ObitTablePSDumpKey */
