/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableSY.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableSY.c
 * ObitTableSY class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableSY";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableSYRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableSYRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableSYClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableSYClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableSYRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableSYRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableSYInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableSYClear (gpointer in);

/** Private: update table specific info */
static void ObitTableSYUpdate (ObitTableSY *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableSYDumpKey (ObitTableSY *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableSYClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableSYRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableSYRow* newObitTableSYRow (ObitTableSY *table)
{
  ObitTableSYRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableSYRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableSYRow));

  /* initialize values */
  out->name = g_strdup("TableSY Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableSYRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->nPol>=1) out->PwrDif1 = fRow + table->PwrDif1Off;
    if (table->nPol>=1) out->PwrSum1 = fRow + table->PwrSum1Off;
    if (table->nPol>=1) out->Gain1 = fRow + table->Gain1Off;
    if (table->nPol>=2) out->PwrDif2 = fRow + table->PwrDif2Off;
    if (table->nPol>=2) out->PwrSum2 = fRow + table->PwrSum2Off;
    if (table->nPol>=2) out->Gain2 = fRow + table->Gain2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableSYRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableSYRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableSYRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableSYRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableSY* newObitTableSY (gchar* name)
{
  ObitTableSY* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableSYClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableSY));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableSYInit((gpointer)out);

 return out;
} /* end newObitTableSY */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableSYGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableSYClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitSYGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param nIF The number of IFs
 * \param nPol The number of polarizations.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableSY* newObitTableSYValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint nIF, oint nPol,
		     ObitErr *err)
{
  ObitTableSY* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS SY";
  gchar *routine = "newObitTableSYValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableSYClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS SY");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableSY */
      if (ObitTableSYIsA(testTab)) { /* it is an ObitTableSY */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableSYConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS SY");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableSYIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableSYConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->nIF = MAX (0, nIF);
  out->nPol = MAX (0, nPol);
  out->revision = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 7 + out->nIF*0 + out->nPol*3 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME INTERVAL ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CAL TYPE ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA NO.");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY   ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQ ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (nPol>=1) {
    desc->FieldName[colNo] = g_strdup("POWER DIF1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  if (nPol>=1) {
    desc->FieldName[colNo] = g_strdup("POWER SUM1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  if (nPol>=1) {
    desc->FieldName[colNo] = g_strdup("POST GAIN1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  if (nPol>=2) {
    desc->FieldName[colNo] = g_strdup("POWER DIF2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  if (nPol>=2) {
    desc->FieldName[colNo] = g_strdup("POWER SUM2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  if (nPol>=2) {
    desc->FieldName[colNo] = g_strdup("POST GAIN2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = nIF;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableSYDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableSYOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableSYClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableSYValue */

/**
 * Convert an ObitTable to an ObitTableSY.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableSY* ObitTableSYConvert (ObitTable* in)
{
  ObitTableSY *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableSY(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableSYConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableSY* ObitTableSYCopy (ObitTableSY *in, ObitTableSY *out, ObitErr *err)
{
  gchar *routine = "ObitTableSYCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableSYClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableSY*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->nIF = in->nIF;
  out->nPol = in->nPol;
  out->nAnt = in->nAnt;
  out->revision = in->revision;
  /* Update class specific info */
  ObitTableSYUpdate (out, err);
    
  return out;
} /* end ObitTableSYCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableSYOpen (ObitTableSY *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableSYOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableSYClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableSYUpdate (in, err);
   
   return retCode;
} /* end ObitTableSYOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iSYRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableSYReadRow  (ObitTableSY *in, olong iSYRow, ObitTableSYRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableSYReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS SY Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iSYRow */
  retCode = ObitTableRead ((ObitTable*)in, iSYRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->CalType = iRow[in->CalTypeOff];
  row->SourID = iRow[in->SourIDOff];
  row->antennaNo = iRow[in->antennaNoOff];
  row->SubA = iRow[in->SubAOff];
  row->FreqID = iRow[in->FreqIDOff];
  if (in->nPol>=1) row->PwrDif1 = fRow + in->PwrDif1Off;
  if (in->nPol>=1) row->PwrSum1 = fRow + in->PwrSum1Off;
  if (in->nPol>=1) row->Gain1 = fRow + in->Gain1Off;
  if (in->nPol>=2) row->PwrDif2 = fRow + in->PwrDif2Off;
  if (in->nPol>=2) row->PwrSum2 = fRow + in->PwrSum2Off;
  if (in->nPol>=2) row->Gain2 = fRow + in->Gain2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableSYReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableSYSetRow  (ObitTableSY *in, ObitTableSYRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "SY Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->nPol>=1) row->PwrDif1 = fRow + in->PwrDif1Off;
  if (in->nPol>=1) row->PwrSum1 = fRow + in->PwrSum1Off;
  if (in->nPol>=1) row->Gain1 = fRow + in->Gain1Off;
  if (in->nPol>=2) row->PwrDif2 = fRow + in->PwrDif2Off;
  if (in->nPol>=2) row->PwrSum2 = fRow + in->PwrSum2Off;
  if (in->nPol>=2) row->Gain2 = fRow + in->Gain2Off;

} /*  end ObitTableSYSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableSYSetRow  
 * \param in       Table to read
 * \param iSYRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableSYWriteRow  (ObitTableSY *in, olong iSYRow, ObitTableSYRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableSYWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS SY Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->CalTypeOff] = row->CalType;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->SubAOff] = row->SubA;
  iRow[in->FreqIDOff] = row->FreqID;
  if (in->nPol>=1)
    if (in->PwrDif1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PwrDif1Col]; i++) 
        fRow[in->PwrDif1Off+i] = row->PwrDif1[i];
    } 
  if (in->nPol>=1)
    if (in->PwrSum1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PwrSum1Col]; i++) 
        fRow[in->PwrSum1Off+i] = row->PwrSum1[i];
    } 
  if (in->nPol>=1)
    if (in->Gain1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Gain1Col]; i++) 
        fRow[in->Gain1Off+i] = row->Gain1[i];
    } 
  if (in->nPol>=2)
    if (in->PwrDif2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PwrDif2Col]; i++) 
        fRow[in->PwrDif2Off+i] = row->PwrDif2[i];
    } 
  if (in->nPol>=2)
    if (in->PwrSum2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PwrSum2Col]; i++) 
        fRow[in->PwrSum2Off+i] = row->PwrSum2[i];
    } 
  if (in->nPol>=2)
    if (in->Gain2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->Gain2Col]; i++) 
        fRow[in->Gain2Off+i] = row->Gain2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iSYRow */
  retCode = ObitTableWrite ((ObitTable*)in, iSYRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableSYWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableSYClose (ObitTableSY *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableSYClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableSYDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableSYClose */

/*---------------Private functions--------------------------*/
/*----------------  TableSY Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableSYRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableSYRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->PwrDif1 = NULL;
  in->PwrSum1 = NULL;
  in->Gain1 = NULL;
  in->PwrDif2 = NULL;
  in->PwrSum2 = NULL;
  in->Gain2 = NULL;

} /* end ObitTableSYRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableSYRow* cast to an Obit*.
 */
void ObitTableSYRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableSYRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableSYRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableSYRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableSYRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableSYRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableSYRowClassInfoDefFn (gpointer inClass)
{
  ObitTableSYRowClassInfo *theClass = (ObitTableSYRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableSYRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableSYRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableSYRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableSYRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableSYRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableSYRowInit;

} /* end ObitTableSYRowClassDefFn */

/*------------------  TableSY  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableSYInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableSY *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableSYInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableSY* cast to an Obit*.
 */
void ObitTableSYClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableSY *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableSYClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableSYClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableSYClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableSYClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableSYClassInfoDefFn (gpointer inClass)
{
  ObitTableSYClassInfo *theClass = (ObitTableSYClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableSYClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableSYClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableSYGetClass;
  theClass->newObit       = (newObitFP)newObitTableSY;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableSYCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableSYClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableSYInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableSYConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableSYOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableSYClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableSYReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableSYWriteRow;

} /* end ObitTableSYClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableSYUpdate (ObitTableSY *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* nIF */
  if (!ObitInfoListGet(in->myDesc->info, "NO_IF", &type, dim, 
		       (gpointer)&in->nIF, err)) return;
   /* nPol */
  if (!ObitInfoListGet(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->nPol, err)) return;
   /* nAnt */
  if (!ObitInfoListGet(in->myDesc->info, "NO_ANT", &type, dim, 
		       (gpointer)&in->nAnt, err)) return;
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "REVISION", &type, dim, 
		       (gpointer)&in->revision);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->CalTypeOff = -1;
  in->CalTypeCol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->SubAOff = -1;
  in->SubACol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->PwrDif1Off = -1;
  in->PwrDif1Col = -1;
  in->PwrSum1Off = -1;
  in->PwrSum1Col = -1;
  in->Gain1Off = -1;
  in->Gain1Col = -1;
  in->PwrDif2Off = -1;
  in->PwrDif2Col = -1;
  in->PwrSum2Off = -1;
  in->PwrSum2Col = -1;
  in->Gain2Off = -1;
  in->Gain2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME INTERVAL ", 14)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "CAL TYPE ", 9)) {
	 in->CalTypeOff = desc->offset[i];
 	 in->CalTypeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE ID  ", 11)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA NO.", 11)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY   ", 11)) {
	 in->SubAOff = desc->offset[i];
 	 in->SubACol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ ID  ", 9)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POWER DIF1", 10)) {
	     in->PwrDif1Off = desc->offset[i];
 	     in->PwrDif1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "POWER SUM1", 10)) {
	     in->PwrSum1Off = desc->offset[i];
 	     in->PwrSum1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "POST GAIN1", 10)) {
	     in->Gain1Off = desc->offset[i];
 	     in->Gain1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "POWER DIF2", 10)) {
	     in->PwrDif2Off = desc->offset[i];
 	     in->PwrDif2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "POWER SUM2", 10)) {
	     in->PwrSum2Off = desc->offset[i];
 	     in->PwrSum2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "POST GAIN2", 10)) {
	     in->Gain2Off = desc->offset[i];
 	     in->Gain2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableSYUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableSYUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableSYUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTableSYUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->SubAOff > -1), err,
       "ObitTableSYUpdate: Could not find column SubA");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableSYUpdate: Could not find column FreqID");
  if (in->nPol>=1) {
    Obit_return_if_fail((in->PwrDif1Off > -1), err,
       "ObitTableSYUpdate: Could not find column PwrDif1");
    Obit_return_if_fail((in->PwrSum1Off > -1), err,
       "ObitTableSYUpdate: Could not find column PwrSum1");
  } /* end of if index in range */
  if (in->nPol>=2) {
    Obit_return_if_fail((in->PwrDif2Off > -1), err,
       "ObitTableSYUpdate: Could not find column PwrDif2");
    Obit_return_if_fail((in->PwrSum2Off > -1), err,
       "ObitTableSYUpdate: Could not find column PwrSum2");
  } /* end of if index in range */
} /* end ObitTableSYUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableSYDumpKey (ObitTableSY *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* nIF */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_IF", type, dim, 
		  (gpointer)&in->nIF);
  /* nPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->nPol);
  /* nAnt */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_ANT", type, dim, 
		  (gpointer)&in->nAnt);
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REVISION", type, dim, 
		  (gpointer)&in->revision);
   
} /* end ObitTableSYDumpKey */
