/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableVL.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableVL.c
 * ObitTableVL class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableVL";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableVLRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableVLRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableVLClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableVLClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableVLRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableVLRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableVLInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableVLClear (gpointer in);

/** Private: update table specific info */
static void ObitTableVLUpdate (ObitTableVL *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableVLDumpKey (ObitTableVL *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableVLClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableVLRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableVLRow* newObitTableVLRow (ObitTableVL *table)
{
  ObitTableVLRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableVLRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableVLRow));

  /* initialize values */
  out->name = g_strdup("TableVL Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableVLRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->Field = cRow + table->FieldOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableVLRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableVLRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableVLRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableVLRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableVL* newObitTableVL (gchar* name)
{
  ObitTableVL* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableVLClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableVL));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableVLInit((gpointer)out);

 return out;
} /* end newObitTableVL */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableVLGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableVLClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitVLGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableVL* newObitTableVLValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		    
		     ObitErr *err)
{
  ObitTableVL* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS VL";
  gchar *routine = "newObitTableVLValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableVLClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS VL");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableVL */
      if (ObitTableVLIsA(testTab)) { /* it is an ObitTableVL */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableVLConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS VL");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableVLIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableVLConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->revision = 1;
  out->BeamMajor = 0.0125;
  out->BeamMinor = 0.0125;
  out->BeamPA = 0.0;
  out->SortOrder = 0;
  out->numIndexed = 1;
  out->index00 = 1;
  out->index01 = 1;
  out->index02 = 1;
  out->index03 = 1;
  out->index04 = 1;
  out->index05 = 1;
  out->index06 = 1;
  out->index07 = 1;
  out->index08 = 1;
  out->index09 = 1;
  out->index10 = 1;
  out->index11 = 1;
  out->index12 = 1;
  out->index13 = 1;
  out->index14 = 1;
  out->index15 = 1;
  out->index16 = 1;
  out->index17 = 1;
  out->index18 = 1;
  out->index19 = 1;
  out->index20 = 1;
  out->index21 = 1;
  out->index22 = 1;
  out->index23 = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 18 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("RA(2000)");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DEC(2000)");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("PEAK INT  ");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MAJOR AX");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MINOR AX");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("POSANGLE");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("Q CENTER");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("U CENTER");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("P FLUX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("I RMS ");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("POL RMS ");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES RMS");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES PEAK");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES FLUX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CENTER X");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CENTER Y");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FIELD  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("JD PROCESSED");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableVLDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableVLOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableVLClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableVLValue */

/**
 * Convert an ObitTable to an ObitTableVL.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableVL* ObitTableVLConvert (ObitTable* in)
{
  ObitTableVL *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableVL(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableVLConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableVL* ObitTableVLCopy (ObitTableVL *in, ObitTableVL *out, ObitErr *err)
{
  gchar *routine = "ObitTableVLCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableVLClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableVL*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  out->BeamMajor = in->BeamMajor;
  out->BeamMinor = in->BeamMinor;
  out->BeamPA = in->BeamPA;
  out->SortOrder = in->SortOrder;
  out->numIndexed = in->numIndexed;
  out->index00 = in->index00;
  out->index01 = in->index01;
  out->index02 = in->index02;
  out->index03 = in->index03;
  out->index04 = in->index04;
  out->index05 = in->index05;
  out->index06 = in->index06;
  out->index07 = in->index07;
  out->index08 = in->index08;
  out->index09 = in->index09;
  out->index10 = in->index10;
  out->index11 = in->index11;
  out->index12 = in->index12;
  out->index13 = in->index13;
  out->index14 = in->index14;
  out->index15 = in->index15;
  out->index16 = in->index16;
  out->index17 = in->index17;
  out->index18 = in->index18;
  out->index19 = in->index19;
  out->index20 = in->index20;
  out->index21 = in->index21;
  out->index22 = in->index22;
  out->index23 = in->index23;
  /* Update class specific info */
  ObitTableVLUpdate (out, err);
    
  return out;
} /* end ObitTableVLCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableVLOpen (ObitTableVL *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableVLOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableVLClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableVLUpdate (in, err);
   
   return retCode;
} /* end ObitTableVLOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iVLRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableVLReadRow  (ObitTableVL *in, olong iVLRow, ObitTableVLRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableVLReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS VL Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iVLRow */
  retCode = ObitTableRead ((ObitTable*)in, iVLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Ra2000 = dRow[in->Ra2000Off];
  row->Dec2000 = dRow[in->Dec2000Off];
  row->PeakInt = fRow[in->PeakIntOff];
  row->MajorAxis = fRow[in->MajorAxisOff];
  row->MinorAxis = fRow[in->MinorAxisOff];
  row->PosAngle = fRow[in->PosAngleOff];
  row->QCenter = fRow[in->QCenterOff];
  row->UCenter = fRow[in->UCenterOff];
  row->PFlux = fRow[in->PFluxOff];
  row->IRMS = fRow[in->IRMSOff];
  row->PolRMS = fRow[in->PolRMSOff];
  row->ResRMS = fRow[in->ResRMSOff];
  row->ResPeak = fRow[in->ResPeakOff];
  row->ResFlux = fRow[in->ResFluxOff];
  row->CenterX = fRow[in->CenterXOff];
  row->CenterY = fRow[in->CenterYOff];
  row->JDProcess = iRow[in->JDProcessOff];
  row->Field = cRow + in->FieldOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableVLReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableVLSetRow  (ObitTableVL *in, ObitTableVLRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "VL Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->Field = cRow + in->FieldOff;

} /*  end ObitTableVLSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableVLSetRow  
 * \param in       Table to read
 * \param iVLRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableVLWriteRow  (ObitTableVL *in, olong iVLRow, ObitTableVLRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableVLWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS VL Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->Ra2000Off] = row->Ra2000;
  dRow[in->Dec2000Off] = row->Dec2000;
  fRow[in->PeakIntOff] = row->PeakInt;
  fRow[in->MajorAxisOff] = row->MajorAxis;
  fRow[in->MinorAxisOff] = row->MinorAxis;
  fRow[in->PosAngleOff] = row->PosAngle;
  fRow[in->QCenterOff] = row->QCenter;
  fRow[in->UCenterOff] = row->UCenter;
  fRow[in->PFluxOff] = row->PFlux;
  fRow[in->IRMSOff] = row->IRMS;
  fRow[in->PolRMSOff] = row->PolRMS;
  fRow[in->ResRMSOff] = row->ResRMS;
  fRow[in->ResPeakOff] = row->ResPeak;
  fRow[in->ResFluxOff] = row->ResFlux;
  fRow[in->CenterXOff] = row->CenterX;
  fRow[in->CenterYOff] = row->CenterY;
  iRow[in->JDProcessOff] = row->JDProcess;
  if (in->FieldCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FieldCol]; i++) 
      cRow[in->FieldOff+i] = row->Field[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iVLRow */
  retCode = ObitTableWrite ((ObitTable*)in, iVLRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableVLWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableVLClose (ObitTableVL *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableVLClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableVLDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableVLClose */

/*---------------Private functions--------------------------*/
/*----------------  TableVL Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableVLRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableVLRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->Field = NULL;

} /* end ObitTableVLRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableVLRow* cast to an Obit*.
 */
void ObitTableVLRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableVLRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableVLRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableVLRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableVLRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableVLRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableVLRowClassInfoDefFn (gpointer inClass)
{
  ObitTableVLRowClassInfo *theClass = (ObitTableVLRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableVLRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableVLRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableVLRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableVLRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableVLRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableVLRowInit;

} /* end ObitTableVLRowClassDefFn */

/*------------------  TableVL  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableVLInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableVL *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableVLInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableVL* cast to an Obit*.
 */
void ObitTableVLClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableVL *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableVLClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableVLClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableVLClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableVLClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableVLClassInfoDefFn (gpointer inClass)
{
  ObitTableVLClassInfo *theClass = (ObitTableVLClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableVLClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableVLClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableVLGetClass;
  theClass->newObit       = (newObitFP)newObitTableVL;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableVLCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableVLClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableVLInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableVLConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableVLOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableVLClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableVLReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableVLWriteRow;

} /* end ObitTableVLClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableVLUpdate (ObitTableVL *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "REVISION", &type, dim, 
		       (gpointer)&in->revision);
  in->BeamMajor = 0.0125; 
  InfoReal.dbl = 0.0125; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "BM_MAJOR", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->BeamMajor = InfoReal.dbl;
  if (type==OBIT_float)  in->BeamMajor = InfoReal.flt;
  in->BeamMinor = 0.0125; 
  InfoReal.dbl = 0.0125; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "BM_MINOR", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->BeamMinor = InfoReal.dbl;
  if (type==OBIT_float)  in->BeamMinor = InfoReal.flt;
  in->BeamPA = 0.0; 
  InfoReal.dbl = 0.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "BM_PA", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->BeamPA = InfoReal.dbl;
  if (type==OBIT_float)  in->BeamPA = InfoReal.flt;
   /* SortOrder */
  in->SortOrder = 0; 
  ObitInfoListGetTest(in->myDesc->info, "SORTORT", &type, dim, 
		       (gpointer)&in->SortOrder);
   /* numIndexed */
  in->numIndexed = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NUM_INDE", &type, dim, 
		       (gpointer)&in->numIndexed);
   /* index00 */
  in->index00 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX00", &type, dim, 
		       (gpointer)&in->index00);
   /* index01 */
  in->index01 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX01", &type, dim, 
		       (gpointer)&in->index01);
   /* index02 */
  in->index02 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX02", &type, dim, 
		       (gpointer)&in->index02);
   /* index03 */
  in->index03 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX03", &type, dim, 
		       (gpointer)&in->index03);
   /* index04 */
  in->index04 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX04", &type, dim, 
		       (gpointer)&in->index04);
   /* index05 */
  in->index05 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX05", &type, dim, 
		       (gpointer)&in->index05);
   /* index06 */
  in->index06 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX06", &type, dim, 
		       (gpointer)&in->index06);
   /* index07 */
  in->index07 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX07", &type, dim, 
		       (gpointer)&in->index07);
   /* index08 */
  in->index08 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX08", &type, dim, 
		       (gpointer)&in->index08);
   /* index09 */
  in->index09 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX09", &type, dim, 
		       (gpointer)&in->index09);
   /* index10 */
  in->index10 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX10", &type, dim, 
		       (gpointer)&in->index10);
   /* index11 */
  in->index11 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX11", &type, dim, 
		       (gpointer)&in->index11);
   /* index12 */
  in->index12 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX12", &type, dim, 
		       (gpointer)&in->index12);
   /* index13 */
  in->index13 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX13", &type, dim, 
		       (gpointer)&in->index13);
   /* index14 */
  in->index14 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX14", &type, dim, 
		       (gpointer)&in->index14);
   /* index15 */
  in->index15 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX15", &type, dim, 
		       (gpointer)&in->index15);
   /* index16 */
  in->index16 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX16", &type, dim, 
		       (gpointer)&in->index16);
   /* index17 */
  in->index17 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX17", &type, dim, 
		       (gpointer)&in->index17);
   /* index18 */
  in->index18 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX18", &type, dim, 
		       (gpointer)&in->index18);
   /* index19 */
  in->index19 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX19", &type, dim, 
		       (gpointer)&in->index19);
   /* index20 */
  in->index20 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX20", &type, dim, 
		       (gpointer)&in->index20);
   /* index21 */
  in->index21 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX21", &type, dim, 
		       (gpointer)&in->index21);
   /* index22 */
  in->index22 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX22", &type, dim, 
		       (gpointer)&in->index22);
   /* index23 */
  in->index23 = 1; 
  ObitInfoListGetTest(in->myDesc->info, "INDEX23", &type, dim, 
		       (gpointer)&in->index23);

  /* initialize column numbers/offsets */
  in->Ra2000Off = -1;
  in->Ra2000Col = -1;
  in->Dec2000Off = -1;
  in->Dec2000Col = -1;
  in->PeakIntOff = -1;
  in->PeakIntCol = -1;
  in->MajorAxisOff = -1;
  in->MajorAxisCol = -1;
  in->MinorAxisOff = -1;
  in->MinorAxisCol = -1;
  in->PosAngleOff = -1;
  in->PosAngleCol = -1;
  in->QCenterOff = -1;
  in->QCenterCol = -1;
  in->UCenterOff = -1;
  in->UCenterCol = -1;
  in->PFluxOff = -1;
  in->PFluxCol = -1;
  in->IRMSOff = -1;
  in->IRMSCol = -1;
  in->PolRMSOff = -1;
  in->PolRMSCol = -1;
  in->ResRMSOff = -1;
  in->ResRMSCol = -1;
  in->ResPeakOff = -1;
  in->ResPeakCol = -1;
  in->ResFluxOff = -1;
  in->ResFluxCol = -1;
  in->CenterXOff = -1;
  in->CenterXCol = -1;
  in->CenterYOff = -1;
  in->CenterYCol = -1;
  in->FieldOff = -1;
  in->FieldCol = -1;
  in->JDProcessOff = -1;
  in->JDProcessCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "RA(2000)", 8)) {
	 in->Ra2000Off = desc->offset[i];
 	 in->Ra2000Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DEC(2000)", 9)) {
	 in->Dec2000Off = desc->offset[i];
 	 in->Dec2000Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PEAK INT  ", 10)) {
	 in->PeakIntOff = desc->offset[i];
 	 in->PeakIntCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MAJOR AX", 8)) {
	 in->MajorAxisOff = desc->offset[i];
 	 in->MajorAxisCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MINOR AX", 8)) {
	 in->MinorAxisOff = desc->offset[i];
 	 in->MinorAxisCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POSANGLE", 8)) {
	 in->PosAngleOff = desc->offset[i];
 	 in->PosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "Q CENTER", 8)) {
	 in->QCenterOff = desc->offset[i];
 	 in->QCenterCol = i;
      }
      if (!strncmp (desc->FieldName[i], "U CENTER", 8)) {
	 in->UCenterOff = desc->offset[i];
 	 in->UCenterCol = i;
      }
      if (!strncmp (desc->FieldName[i], "P FLUX", 6)) {
	 in->PFluxOff = desc->offset[i];
 	 in->PFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "I RMS ", 6)) {
	 in->IRMSOff = desc->offset[i];
 	 in->IRMSCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POL RMS ", 8)) {
	 in->PolRMSOff = desc->offset[i];
 	 in->PolRMSCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES RMS", 7)) {
	 in->ResRMSOff = desc->offset[i];
 	 in->ResRMSCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES PEAK", 8)) {
	 in->ResPeakOff = desc->offset[i];
 	 in->ResPeakCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES FLUX", 8)) {
	 in->ResFluxOff = desc->offset[i];
 	 in->ResFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CENTER X", 8)) {
	 in->CenterXOff = desc->offset[i];
 	 in->CenterXCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CENTER Y", 8)) {
	 in->CenterYOff = desc->offset[i];
 	 in->CenterYCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FIELD  ", 7)) {
	 in->FieldOff = desc->offset[i];
 	 in->FieldCol = i;
      }
      if (!strncmp (desc->FieldName[i], "JD PROCESSED", 12)) {
	 in->JDProcessOff = desc->offset[i];
 	 in->JDProcessCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->Ra2000Off > -1), err,
       "ObitTableVLUpdate: Could not find column Ra2000");
  Obit_return_if_fail((in->Dec2000Off > -1), err,
       "ObitTableVLUpdate: Could not find column Dec2000");
  Obit_return_if_fail((in->PeakIntOff > -1), err,
       "ObitTableVLUpdate: Could not find column PeakInt");
  Obit_return_if_fail((in->MajorAxisOff > -1), err,
       "ObitTableVLUpdate: Could not find column MajorAxis");
  Obit_return_if_fail((in->MinorAxisOff > -1), err,
       "ObitTableVLUpdate: Could not find column MinorAxis");
  Obit_return_if_fail((in->PosAngleOff > -1), err,
       "ObitTableVLUpdate: Could not find column PosAngle");
  Obit_return_if_fail((in->QCenterOff > -1), err,
       "ObitTableVLUpdate: Could not find column QCenter");
  Obit_return_if_fail((in->UCenterOff > -1), err,
       "ObitTableVLUpdate: Could not find column UCenter");
  Obit_return_if_fail((in->PFluxOff > -1), err,
       "ObitTableVLUpdate: Could not find column PFlux");
  Obit_return_if_fail((in->IRMSOff > -1), err,
       "ObitTableVLUpdate: Could not find column IRMS");
  Obit_return_if_fail((in->PolRMSOff > -1), err,
       "ObitTableVLUpdate: Could not find column PolRMS");
  Obit_return_if_fail((in->ResRMSOff > -1), err,
       "ObitTableVLUpdate: Could not find column ResRMS");
  Obit_return_if_fail((in->ResPeakOff > -1), err,
       "ObitTableVLUpdate: Could not find column ResPeak");
  Obit_return_if_fail((in->ResFluxOff > -1), err,
       "ObitTableVLUpdate: Could not find column ResFlux");
  Obit_return_if_fail((in->CenterXOff > -1), err,
       "ObitTableVLUpdate: Could not find column CenterX");
  Obit_return_if_fail((in->CenterYOff > -1), err,
       "ObitTableVLUpdate: Could not find column CenterY");
  Obit_return_if_fail((in->FieldOff > -1), err,
       "ObitTableVLUpdate: Could not find column Field");
} /* end ObitTableVLUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableVLDumpKey (ObitTableVL *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REVISION", type, dim, 
		  (gpointer)&in->revision);
  /* BeamMajor */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "BM_MAJOR", type, dim, 
		  (gpointer)&in->BeamMajor);
  /* BeamMinor */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "BM_MINOR", type, dim, 
		  (gpointer)&in->BeamMinor);
  /* BeamPA */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "BM_PA", type, dim, 
		  (gpointer)&in->BeamPA);
  /* SortOrder */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "SORTORT", type, dim, 
		  (gpointer)&in->SortOrder);
  /* numIndexed */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NUM_INDE", type, dim, 
		  (gpointer)&in->numIndexed);
  /* index00 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX00", type, dim, 
		  (gpointer)&in->index00);
  /* index01 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX01", type, dim, 
		  (gpointer)&in->index01);
  /* index02 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX02", type, dim, 
		  (gpointer)&in->index02);
  /* index03 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX03", type, dim, 
		  (gpointer)&in->index03);
  /* index04 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX04", type, dim, 
		  (gpointer)&in->index04);
  /* index05 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX05", type, dim, 
		  (gpointer)&in->index05);
  /* index06 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX06", type, dim, 
		  (gpointer)&in->index06);
  /* index07 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX07", type, dim, 
		  (gpointer)&in->index07);
  /* index08 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX08", type, dim, 
		  (gpointer)&in->index08);
  /* index09 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX09", type, dim, 
		  (gpointer)&in->index09);
  /* index10 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX10", type, dim, 
		  (gpointer)&in->index10);
  /* index11 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX11", type, dim, 
		  (gpointer)&in->index11);
  /* index12 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX12", type, dim, 
		  (gpointer)&in->index12);
  /* index13 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX13", type, dim, 
		  (gpointer)&in->index13);
  /* index14 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX14", type, dim, 
		  (gpointer)&in->index14);
  /* index15 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX15", type, dim, 
		  (gpointer)&in->index15);
  /* index16 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX16", type, dim, 
		  (gpointer)&in->index16);
  /* index17 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX17", type, dim, 
		  (gpointer)&in->index17);
  /* index18 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX18", type, dim, 
		  (gpointer)&in->index18);
  /* index19 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX19", type, dim, 
		  (gpointer)&in->index19);
  /* index20 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX20", type, dim, 
		  (gpointer)&in->index20);
  /* index21 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX21", type, dim, 
		  (gpointer)&in->index21);
  /* index22 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX22", type, dim, 
		  (gpointer)&in->index22);
  /* index23 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "INDEX23", type, dim, 
		  (gpointer)&in->index23);
   
} /* end ObitTableVLDumpKey */
